#define _UNICODE
#define UNICODE
#include <stdio.h>
#include <time.h>
#include <conio.h>
#include <errno.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
#include <malloc.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys\locking.h>
#include <share.h>
#include <sys/utime.h>
#include <string.h>
#include <tchar.h>
#include <direct.h>
#include <wchar.h>

//Wide code version of CP32 for Windows ONLY
#include <dos.h>
#define _WIN32_WINNT 0x0400
#include <windows.h>
#include <winver.h>
#include <commctrl.h>

long path_handle;
struct _wfinddatai64_t  fileinfo;
struct _wfinddata_t finddata;
wchar_t filenotfound[] = {0};
HINSTANCE hinst,g_hinst;
HWND hwndParent,hwndPB;
RECT rcClient;  // client area of parent window 
int cyVScroll;  // height of scroll bar arrow 
    // Ensure that the common control DLL is loaded and create a 
    // progress bar along the bottom of the client area of the 
    // parent window. Base the height of the progress bar on 
    // the height of a scroll bar arrow. 
HWND hWnd;
int ProgressBar = -1;
int errnbr=0;
int filekt=0;
__int64 totalSize=0;

#define DosFindFirst(path,handle,attr,fileinfo,len,num,templong) _findfirst(path,fileinfo)
#define FILE_NORMAL _A_NORMAL
#define FILE_HIDDEN _A_HIDDEN
#define FILE_SYSTEM _A_SYSTEM
#define FILE_DIRECTORY _A_SUBDIR

#define DELIM L"/"
#define RD "rb"
#define WR "wb"
#define BUFLEN 65024
#define BLKSI 2000
#define FAILKT 10
#define MAXBUF 32
#define MAXPTR 33
unsigned short nummatch=1;
wchar_t toname[_MAX_PATH],topath[_MAX_PATH];
BYTE *bufptr[MAXPTR];
wchar_t fromfull[_MAX_PATH], tofull[_MAX_PATH], *exclude_arg;
int nbufs=0,rc =0, repl = 0, fnew = 0, changed = 0, wnew = 0, timespan = 0, exclude_arg_size;
char input_pacing = 0, output_pacing = 0, archive = 0, overwrite_read_only = 0;
int versions = 5, exclude_count = 0;
char subdirectories = 0, hiddensystem = 0, set_hiddensystem = 0;
char logall = 1, id = 0, subverbose = 0, safeoverwrite = 0;
struct exclude_struct {
	struct exclude_struct *next;
	wchar_t *value;
} *first_exclude=NULL, *exclude_entry, *current_exclude, exclude_temp;

long input_pacing_interval = -1, output_pacing_interval = -1;
unsigned input_pacing_size, output_pacing_size;
int buflen;
unsigned vblksi;
char debug = 0;
FILE *vfile = NULL;
char batch = 0;
struct _stati64 dta,dta1;
int blocksi = BUFLEN;
long current_record;
FILE *logfi = NULL;
FILE *cpyfi = NULL;
int start, o;
DWORD to_version[2],from_version[2];
char firsttime=0, move=0, checkPoint = 0, restart = 0, quiet = 0;
char copytoend = 0;
wchar_t vtime[16], vsize[16], vname[_MAX_PATH], vblock[16];
char timeit = 0, useCopyFile = 0;
wchar_t verify_name[_MAX_PATH], vctime[32], temp[_MAX_PATH];
unsigned blocksize = 0;

wchar_t *translate(wchar_t *source, wchar_t *from, wchar_t *to) {
	// global string translation
	// translate characters in source, replacing a character in from with
	// the corresponding character from to
	// If from is longer than to, extend the to string with spaces

	int lnf = wcslen(from);
	int lnt = wcslen(to);
	int tsize = lnf * sizeof(wchar_t);
	int i;
	wchar_t *s=source, *t=to, *f=from, *match;
	// if the from string is larger than the to string
	// make a bigger to string and fill with blanks;
	if (lnf > lnt) {
		t = (wchar_t *)malloc(lnf * sizeof(wchar_t));
		if (t == NULL) 
			return NULL;
		wcscpy_s(t,tsize,to);
		for (i = lnt; i < lnf; ++i)
			*(t+i) = L' ';
		*(t+i) = 0;
	}

	while (*s) {
		// if *s is in *f, replace with the corresponding character in *t
		match = wcschr(f,*s);
		if (match) 
			// found a matching character in the from string
			*s = *(t +( match - f));
		++s;
	}

	return source;
}




/*
    CP32 -- Unix like copy utility with added features
    Copyright (C) 2003-2006  Norm London, London Computing

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	norm_london@londoncomputing.com

    Compile with Visual Studio 6 or later.  Requires comdlg32.lib odbc32.lib odbccp32.lib winmm.lib
	cl cp32w.c /link odbc32.lib odbccp32.lib winmm.lib version.lib comctl32.lib

	12/3/2006 -- Corrected output errors when file not found or IO error reported.
	2/21/2009 -- Modified mechanism for safe copy.  Sets time properly on copied file.

*/
/* Version 3.33 -- Modified to not copy when version/time date same */
#define LMAX	512
#define PMAX	512
#define ANY	    '?'
#define CLASS	'['
#define ENDCLASS ']'
#define ESCAPE  '\\'
#define STAR	'*'
#define RANGE '-'
#define ENDPAT  0
/* #define USE_CLASS to have uxmatch check for [...] */
/* Check line against pattern using Unix Wildcard sequence */
int uxmatch(wchar_t *line, wchar_t *pattern)
/* (partial) line to match	   */
/* (partial) pattern to match	 */
{
	register wchar_t   *l;	    /* Current line pointer	      */
	register wchar_t   *p;	    /* Current pattern pointer      */
	TCHAR		   op;	      	/* Pattern operation	      */
	char  escape = 0;
#ifdef USE_CLASS
	char inclass = 0, foundmatch = 0,lowvalue = 0;
#endif
	l = line;
	p = pattern;
	if (*p == ENDPAT)
		return 1;

	while ((op = *p++) != ENDPAT) {
		escape = 0;
		if (op == L'\\') {
			op = *p++;
			if (op)		
				escape = 1;
			else {	/* pattern ends with \. look for \ */
				--p;
				op = '\\';
			}
		}
#ifdef USE_CLASS
		if (inclass) {
			/* currently scanning a class spec [abc-de] */
			if (!foundmatch) {
				/* and we haven't found a match yet */
				if (lowvalue) {
				/* but we are in a range c-e */
				/* op is high value of range */
					if (towlower(*l) >= lowvalue && towlower(*l) <= towlower(op)) {
						/* we found a match */
						foundmatch = 1;
						lowvalue = 0;
						continue;
					}
				/* no match found, return failure */
					lowvalue = 0;
				}
				else {
					/* not in a range */
					if (*p == RANGE)  {
						/* in a range, op is low value */
						lowvalue = (wchar_t) towlower(op);
						++p;
						continue;
					}
					else
						lowvalue = 0;

					if (towlower(*l) == towlower(op)) {
						/* found match, whoopie */
						foundmatch = 1;
						continue;
					}
				}
			}
			if (op == ENDCLASS && !escape) {
				if (!foundmatch)					
					return 0;		/* not found, sorry charlie */
				inclass = 0;
				++l;
			}
		}
		else 
#endif		
		{
			switch (op) {
			case ANY:
				if (*l++ == '\0')
					return(0);
				break;
#ifdef USE_CLASS
			case CLASS:
				inclass = 1;
				lowvalue = 0;
				foundmatch = 0;
				break;				
#endif
			case STAR:		 /* Zero or more characters	*/
				/* match line against rest of pattern */
				if (*l == 0)
					return 1;
				while (*l)
					if (uxmatch(l++,p))
						return 1;
				return 0;		 /* Nothing else worked */
			default:
				if (towlower(*l) != towlower(op))
					return(0);
				l++;
				break;
			}
		}
	}
	return *l == 0 ? 1 : 0;   /* if everything matches and at end of string, ok */
}

#ifdef VERIFYCRC
/* Calculate, intelligently, the CRC of a dataset incrementally given a
* buffer full at a time.
* Initialize crc to 0 for XMODEM, -1 for CCITT.
*
* :
* newcrc = updcrc( oldcrc, bufadr, buflen )
* unsigned int oldcrc, buflen;
* wchar_t *bufadr;
*
* Compile with -DTEST to generate program that prints CRC of stdin to stdout.
* Compile with -DMAKETAB to print values for crctab to stdout
*/

/* the CRC polynomial. This is used by XMODEM (almost CCITT).
* If you change P, you must change crctab[]'s initial value to what is
* printed by initcrctab()
*/
#define      P   0x1021

/* number of bits in CRC: don't change it. */
#define W    16

/* this the number of bits per char: don't change it. */
#define B    8

static unsigned short crctab[1<<B] = { /* as calculated by initcrctab() */
	0x0000,  0x1021,  0x2042,  0x3063,  0x4084,  0x50a5,  0x60c6,  0x70e7,
	0x8108,  0x9129,  0xa14a,  0xb16b,  0xc18c,  0xd1ad,  0xe1ce,  0xf1ef,
	0x1231,  0x0210,  0x3273,  0x2252,  0x52b5,  0x4294,  0x72f7,  0x62d6,
	0x9339,  0x8318,  0xb37b,  0xa35a,  0xd3bd,  0xc39c,  0xf3ff,  0xe3de,
	0x2462,  0x3443,  0x0420,  0x1401,  0x64e6,  0x74c7,  0x44a4,  0x5485,
	0xa56a,  0xb54b,  0x8528,  0x9509,  0xe5ee,  0xf5cf,  0xc5ac,  0xd58d,
	0x3653,  0x2672,  0x1611,  0x0630,  0x76d7,  0x66f6,  0x5695,  0x46b4,
	0xb75b,  0xa77a,  0x9719,  0x8738,  0xf7df,  0xe7fe,  0xd79d,  0xc7bc,
	0x48c4,  0x58e5,  0x6886,  0x78a7,  0x0840,  0x1861,  0x2802,  0x3823,
	0xc9cc,  0xd9ed,  0xe98e,  0xf9af,  0x8948,  0x9969,  0xa90a,  0xb92b,
	0x5af5,  0x4ad4,  0x7ab7,  0x6a96,  0x1a71,  0x0a50,  0x3a33,  0x2a12,
	0xdbfd,  0xcbdc,  0xfbbf,  0xeb9e,  0x9b79,  0x8b58,  0xbb3b,  0xab1a,
	0x6ca6,  0x7c87,  0x4ce4,  0x5cc5,  0x2c22,  0x3c03,  0x0c60,  0x1c41,
	0xedae,  0xfd8f,  0xcdec,  0xddcd,  0xad2a,  0xbd0b,  0x8d68,  0x9d49,
	0x7e97,  0x6eb6,  0x5ed5,  0x4ef4,  0x3e13,  0x2e32,  0x1e51,  0x0e70,
	0xff9f,  0xefbe,  0xdfdd,  0xcffc,  0xbf1b,  0xaf3a,  0x9f59,  0x8f78,
	0x9188,  0x81a9,  0xb1ca,  0xa1eb,  0xd10c,  0xc12d,  0xf14e,  0xe16f,
	0x1080,  0x00a1,  0x30c2,  0x20e3,  0x5004,  0x4025,  0x7046,  0x6067,
	0x83b9,  0x9398,  0xa3fb,  0xb3da,  0xc33d,  0xd31c,  0xe37f,  0xf35e,
	0x02b1,  0x1290,  0x22f3,  0x32d2,  0x4235,  0x5214,  0x6277,  0x7256,
	0xb5ea,  0xa5cb,  0x95a8,  0x8589,  0xf56e,  0xe54f,  0xd52c,  0xc50d,
	0x34e2,  0x24c3,  0x14a0,  0x0481,  0x7466,  0x6447,  0x5424,  0x4405,
	0xa7db,  0xb7fa,  0x8799,  0x97b8,  0xe75f,  0xf77e,  0xc71d,  0xd73c,
	0x26d3,  0x36f2,  0x0691,  0x16b0,  0x6657,  0x7676,  0x4615,  0x5634,
	0xd94c,  0xc96d,  0xf90e,  0xe92f,  0x99c8,  0x89e9,  0xb98a,  0xa9ab,
	0x5844,  0x4865,  0x7806,  0x6827,  0x18c0,  0x08e1,  0x3882,  0x28a3,
	0xcb7d,  0xdb5c,  0xeb3f,  0xfb1e,  0x8bf9,  0x9bd8,  0xabbb,  0xbb9a,
	0x4a75,  0x5a54,  0x6a37,  0x7a16,  0x0af1,  0x1ad0,  0x2ab3,  0x3a92,
	0xfd2e,  0xed0f,  0xdd6c,  0xcd4d,  0xbdaa,  0xad8b,  0x9de8,  0x8dc9,
	0x7c26,  0x6c07,  0x5c64,  0x4c45,  0x3ca2,  0x2c83,  0x1ce0,  0x0cc1,
	0xef1f,  0xff3e,  0xcf5d,  0xdf7c,  0xaf9b,  0xbfba,  0x8fd9,  0x9ff8,
	0x6e17,  0x7e36,  0x4e55,  0x5e74,  0x2e93,  0x3eb2,  0x0ed1,  0x1ef0
};

unsigned short
updcrc(unsigned short icrc,BYTE *icp, unsigned int icnt) {
	register unsigned short crc = icrc;
	register BYTE *cp = icp;
	register unsigned int cnt = icnt;

	while ( cnt-- ) {
		crc = (crc<<B) ^ crctab[(crc>>(W-B)) ^ *cp++];
	}

	return( crc );
}
#endif

int file_excluded(wchar_t *file) {
	// If the file name matches a name in the excluded list, return 1
	wchar_t filename[_MAX_PATH];
	char exclude_me = 0;

	wcscpy_s(filename,_MAX_PATH,file);
	translate(filename,L"\\",L"/");  // Use forward slashes as directory seperators
	_wcsupr_s(filename,_MAX_PATH);
	if (first_exclude) {
		for (current_exclude=first_exclude;current_exclude;current_exclude= current_exclude->next) {
			if (uxmatch(filename, current_exclude->value)) {
				// File is to be excluded
				exclude_me = 1;
				break;
			}
		}
	}
	return (exclude_me);
}




HWND GetConsoleHwnd(void) { 
#define MY_BUFSIZE 1024 // buffer size for console window titles
    HWND hwndFound;         // this is what is returned to the caller
    TCHAR pszNewWindowTitle[MY_BUFSIZE]; // contains fabricated WindowTitle
    TCHAR pszOldWindowTitle[MY_BUFSIZE]; // contains original WindowTitle

    // fetch current window title

    GetConsoleTitle(pszOldWindowTitle, MY_BUFSIZE);
    // format a "unique" NewWindowTitle
    wsprintf(pszNewWindowTitle,L"%d/%d",
                GetTickCount(),
                GetCurrentProcessId());
    // change current window title
    SetConsoleTitle(pszNewWindowTitle);
    // ensure window title has been updated
    Sleep(40);
    // look for NewWindowTitle
    hwndFound=FindWindow(NULL, pszNewWindowTitle);
    // restore original window title
    SetConsoleTitle(pszOldWindowTitle);
    return(hwndFound);
} 

int ShowProgressBar(wchar_t *title) {
	TCHAR titlec[256];
	hinst = GetModuleHandle (NULL);
	g_hinst = hinst;

	// hwndParent = GetForegroundWindow();
	hwndParent = GetConsoleHwnd();
	// GetWindowRect(hwndParent, &rcClient); 
	cyVScroll = GetSystemMetrics(SM_CYVSCROLL); 
	wsprintf(titlec,L"%ls",title);
	hWnd = CreateWindow(L"STATIC", titlec, WS_CHILD|WS_CAPTION, 
		// rcClient.top, rcClient.left, 
		0,0,
		cyVScroll*25, 
		cyVScroll+cyVScroll+cyVScroll/2,
		hwndParent, NULL, g_hinst, NULL);

	if (!hWnd) 
		return 0; //Can't create bar, return bad status

	ShowWindow(hWnd, SW_SHOW);
	UpdateWindow(hWnd);
	hwndParent = hWnd; 
	GetClientRect(hwndParent, &rcClient); 
	InitCommonControls(); 
	hwndPB = CreateWindowEx(0, PROGRESS_CLASS, (LPWSTR) NULL, 
		WS_CHILD | WS_VISIBLE, rcClient.left, 
		rcClient.top, 
		rcClient.right, cyVScroll, 
		hwndParent, (HMENU) 0, g_hinst, NULL); 

    // Set the range and increment of the progress bar. 
	// SendMessage(hwndPB, PBM_SETRANGE, 0, 100); 
	// SendMessage(hwndPB, PBM_SETSTEP, (WPARAM) 1, 0); 
	SendMessage(hwndPB, PBM_SETPOS, (WPARAM) 0, 0); 
	return 1;
}

void KillProgressBar() {
    DestroyWindow(hwndPB); 
	DestroyWindow(hWnd);
}


int winFileVersion(wchar_t *path,DWORD file_version[2]) {
	BYTE   *abData;
	DWORD  handle;
	unsigned int  dwSize;
	TCHAR pathc[_MAX_PATH];
	LPDWORD addressofhandle = &handle;
	LPTSTR addressofpath = pathc;
//	LPBYTE lpBuffer;
	VS_FIXEDFILEINFO *lpBuffer;
//	Get File Version Info, if present 

	file_version[0]=0;
	file_version[1]=0;
	wsprintf(pathc,L"%ls",path);

	if (!wnew)
		return 0;
	dwSize = GetFileVersionInfoSize(addressofpath, addressofhandle);
	if (dwSize > 0) {
		abData = (BYTE *)malloc((unsigned)dwSize);
		if (abData != NULL) {
			GetFileVersionInfo(pathc, handle, dwSize, abData);
			VerQueryValue(abData, L"\\", &lpBuffer, &dwSize);
			if (dwSize!=0) {    
				//memcpy(&fileinfo,lpBuffer,sizeof(fileinfo));
				file_version[0] = lpBuffer->dwFileVersionMS;
				file_version[1] = lpBuffer->dwFileVersionLS;
				free(abData);
				return 1;
			}
			free(abData);
			return 0;
		}
		return 0;
	}
	return 0;
}


int is_stream(wchar_t *to_path) {
	// look at name.  If it specifies a stream return 1 else 0
	wchar_t temp_path[_MAX_PATH];
	wchar_t *s,*colon;
	wcscpy_s(temp_path,_MAX_PATH,to_path);
	
//	if the name specifies a stream, then remove stream info
	s = temp_path;
	if (temp_path[1]==':')
		s += 2;
	colon = wcschr(s,':');
	if (colon) // There is another colon in the name.  The name specifies a stream
		return 1;
	else
		return 0;
}

// is_dir checks the path and returns a status of:
//	1 -- The path points to a directory
//	0 -- The path does not exist
//	-1 -- The path points to a file

int is_dir(wchar_t *to_path) {
	wchar_t temp_path[_MAX_PATH];
	wchar_t *s,*colon;
	int k;
	struct _stat dta;
	wcscpy_s(temp_path,_MAX_PATH,to_path);
	
//	if the name specifies a stream, then remove stream info
	s = temp_path;
	if (temp_path[1]==':')
		s += 2;
	colon = wcschr(s,':');
	if (colon) // There is another colon in the name.  The name specifies a stream
		*colon = 0;

	/* If path is x:\ then don't remove trailing \ */
	k = wcslen(temp_path) - 1;
	if (k > 2)
		if (temp_path[k] == '\\' || temp_path[k] == '/')
			temp_path[k] = 0;

	if ((k == 2)  && (temp_path[1] != ':')) 
		if (temp_path[k] == '\\' || temp_path[k] == '/')
			temp_path[k] = 0;

	if (_wstat(temp_path,&dta) == 0) {
		/* Found the entry, if IFDIR, then DIRECTORY; ELSE FILE */
		if (dta.st_mode & S_IFDIR)
			return 1;
		else
			return -1;
	}
	else { 
		long find_handle;
		struct _wfinddata_t fileinfo;
		/* Not found by Stat but could be an ALIAS name
		do a find_first of path\*.*.  If find something,then
		path is an alias, return 1; 	if nothing then return 0 */
		wcscat_s(temp_path,_MAX_PATH,L"\\*"); 
		if ((find_handle = _wfindfirst(temp_path, &fileinfo)) == -1)
			return 0;
		else {
			_findclose(find_handle);
			return 1;
		}
	}
}

void close_log_files(void) {
	if (logfi) fclose(logfi);
	if (cpyfi) fclose(cpyfi);
}

void free_all_buffs(void) {
	int k;
	for (k=0;k<=nbufs && bufptr[k] != NULL;++k)
		free(bufptr[k]);
}

unsigned allocate_buffers(char checkPoint) {
//	long maxram = (long) (MAXBUF) * (long) (BUFLEN);
	int  maxbuf = MAXBUF;
	unsigned buflen, newlen;
	newlen = BUFLEN;

	if (checkPoint)
		/* If taking a checkpoint, force a block to be no bigger than
		a single blocksize.	This significantly slows down the program
		when running locally or on a LAN.  Use this parameter only
		when running on a WAN */
		maxbuf = 2;
	do {
		/* allocate buffers until no more room */
		for (nbufs=0,buflen = newlen;nbufs < maxbuf;++nbufs) {
			bufptr[nbufs] = (BYTE *) malloc(buflen);
			if (bufptr[nbufs] == NULL)
				break;
		}
		--nbufs;
		newlen >>= 1;
	}
	while (nbufs < 0 && newlen > 8192);

	if (nbufs < 0) {
		if (batch)
			printf(" Insufficient Memory\n");
		else
			fprintf(stderr," Insufficient Memory\n");
		if (logfi)
			fprintf(logfi," Insufficient memory\n");
		close_log_files();
		exit(8);
	}

	if (nbufs > 0) {
		free(bufptr[nbufs]); /* free a block to ensure room for opens, etc. */
		--nbufs;
	}
	else  {
		/* only one buffer, allocate half of memory */
		buflen = newlen;
		realloc(bufptr+0,buflen);
	}
	
	if (vblksi > buflen) {
		fprintf(stderr," Insufficient Memory.  Verification can not be performed.\n");
		if (logfi)
			fprintf(logfi," Insufficient Memory.  Verification can not be performed.\n");
		free_all_buffs();
		close_log_files();
		exit(8);
	}
	else if (vblksi > 0)
		buflen = (buflen / vblksi) * vblksi;
		

	if (debug)
		fprintf(stderr,
		"\nBuffer Size = %ld, Number of Buffers = %d, Total Size = %ld\n", 
		(long)buflen, nbufs+1,(long)buflen * (nbufs+1) ); 

	
	/* if pacing specified, set buflen to pacing size */
	if (input_pacing) {
		if (input_pacing_size <= buflen)
			buflen = input_pacing_size;
		else {
			input_pacing_interval = (input_pacing_interval * buflen) / input_pacing_size;
			if (input_pacing_interval == 0)
				input_pacing_interval = 1;
			input_pacing_size = buflen;
			if (!quiet)
				fprintf(stderr,"Input pacing reset to %ld bytes / %ld milliseconds.\n",
				input_pacing_size, input_pacing_interval);
			if (logfi)
				fprintf(logfi,"Input pacing reset to %ld bytes / %ld milliseconds.\n",
					input_pacing_size, input_pacing_interval);

		}
	}

	if (output_pacing) {
		if (output_pacing_size <= buflen)
			buflen = output_pacing_size;
		else {
			output_pacing_interval = (output_pacing_interval * buflen) / output_pacing_size;
			if (output_pacing_interval == 0)
				output_pacing_interval = 1;
			output_pacing_size = buflen;
			if (!quiet)
				fprintf(stderr,"Output pacing reset to %ld bytes / %ld milliseconds.\n",
				output_pacing_size, output_pacing_interval);
			if (logfi)
                fprintf(logfi,"Output pacing reset to %ld bytes / %ld milliseconds.\n",
				output_pacing_size, output_pacing_interval);

		}
	}
	
	return buflen;
}        

char klock[] = "|/-\\";
unsigned int clk=0;
void spindial() {
	if (!quiet) {
		printf("%c\b",klock[clk%4]);
		++clk;
	}
}

DWORD CALLBACK CopyProgressRoutine(
  LARGE_INTEGER TotalFileSize,          // file size
  LARGE_INTEGER TotalBytesTransferred,  // bytes transferred
  LARGE_INTEGER StreamSize,             // bytes in stream
  LARGE_INTEGER StreamBytesTransferred, // bytes transferred for stream
  DWORD dwStreamNumber,                 // current stream
  DWORD dwCallbackReason,               // callback reason
  HANDLE hSourceFile,                   // handle to source file
  HANDLE hDestinationFile,              // handle to destination file
  LPVOID lpData                         // from CopyFileEx
) {
	_int64 pct;
	DWORD SreamNumber, CallbackReason; //not needed, removes warning
	HANDLE SourceFile, DestinationFile;
	LARGE_INTEGER tempStreamBytesTransferred, tempStreamSize;

	SreamNumber = dwStreamNumber; //not needed, removes warning
	CallbackReason = dwCallbackReason;
	DestinationFile = hDestinationFile;
	SourceFile = hSourceFile;
	tempStreamBytesTransferred = StreamBytesTransferred;
	tempStreamSize = StreamSize;


	if (TotalFileSize.QuadPart)
		pct = (_int64)(TotalBytesTransferred.QuadPart*(_int64)100)/(TotalFileSize.QuadPart)  ;
	else 
		pct = 0;

	if (!batch)
		spindial();
	
    if (TotalBytesTransferred.QuadPart) {
		if (!quiet) {
			printf("\b\b\b%2I64d%c",pct,'%');
			if (ProgressBar == -1)
				if (pct < 3) 
					ProgressBar = ShowProgressBar(lpData);
				else
					ProgressBar = 0;
			if (ProgressBar == 1)
				SendMessage(hwndPB, PBM_SETPOS, (WPARAM) pct, 0); 
		}
    }

	return PROGRESS_CONTINUE;
}


unsigned errkt;

int copyfile(
WCHAR *fromIN,
WCHAR *toIN,
time_t a_time,
time_t m_time,
char checkPoint,
char restart,
char useCopyFile)
{
	DWORD attributes;
	WCHAR from[_MAX_PATH],to[_MAX_PATH];
//	OSVERSIONINFO osvi;
	int in,out,vkt;
	BYTE *bptr, verified, time_set;
	char cp;

#ifdef VERIFYCRC
	char vcrc16[10];
	unsigned crc16;
	int ln1,o;
#endif
	struct _utimbuf fromtime;
	_int64 pct,filelen,filelen2,ppct;
	time_t copy_start, copy_end, copy_time;
	DWORD read_start_time, read_end_time, timenow;
	DWORD write_start_time, write_end_time;
	TCHAR fromU[_MAX_PATH+16],toU[_MAX_PATH];
	int k,i,lo,rc = 0,ln,l,blen,oc, openflags,rcin=0;
	struct _stati64 statbuf,statbuf_out,statbuf_temp;
	TCHAR temp_path[_MAX_PATH], *s, *colon, temp_name[_MAX_PATH], temp_time[_MAX_PATH];

	_int64 fromsize;
	FILE *fi;
	int fih;
	PVOID *lpMsgBuf;
	
	wcscpy_s(to,_MAX_PATH,toIN);
	wcscpy_s(from,_MAX_PATH,fromIN);

	//GetVersionEx(&osvi);
	//winmajor = osvi.dwMajorVersion;
	//winminor = osvi.dwMinorVersion;
	
	read_start_time = timeGetTime();
	cp = checkPoint;
	write_start_time = timeGetTime();
	ProgressBar = -1;
	errkt = 0;
	wcscpy_s(toU,_MAX_PATH,to);
	wcscpy_s(fromU,_MAX_PATH,from);

	// compare upper case versions.  If not WIN32, assume case sensitive
    _wcsupr_s(toU,_MAX_PATH);
    _wcsupr_s(fromU,_MAX_PATH);

    if (wcscmp(toU,fromU) == 0)
		return 6; /* can't copy a file to itself */

	filelen = 0;

	wcscpy_s(temp_path,_MAX_PATH,from);
//	if the name specifies a stream, then remove stream info
	s = temp_path;
	if (temp_path[1]==':')
		s += 2;
	colon = wcschr(s,':');
	if (colon) {
		// There is another colon in the name.  The name specifies a stream
		// remove the stream part from the name for stat
		// get the actual file size
		*colon = 0;
		_wfopen_s(&fi,from,L"r");
		if (fi == NULL) {
			errnbr = ferror(fi);
			return 1;
		}
		fih = _fileno(fi);
		fromsize = _filelengthi64(fih);
		fclose(fi);
		rc = _wstati64(temp_path,&statbuf);
		if (rc) {
			errnbr = errno;
			return 1; // Unable to read file
		}
		statbuf.st_size = fromsize;
	}
	else {
		rc = _wstati64(temp_path,&statbuf);
		if (rc) {
			errnbr = errno;
		    return 1; // Unable to read file
		}
	}
	// get info needed to calculate % of file copied
	filelen2 = statbuf.st_size+ 1;
	pct = ppct = (filelen*100) / filelen2;
	if (!batch && !quiet && id==0)
		printf(" %2I64d%c",pct,'%');

	
	// Check outputfile for read only file
	temp_name[0] = 0; // if temp_name empty, no rename done
	oc = _wstati64(to,&statbuf_out);
	// if id flag set, make no changes
	if (oc == 0 && id == 0) {
		// output file exists
		if (!(statbuf_out.st_mode & _S_IWRITE) && overwrite_read_only) 
		// output file is readonly -- change from readonly to standard
			oc = _wchmod(to,_S_IWRITE);
		if (safeoverwrite && !restart) {
			int trycount;
			// set the output to a temporary file name made by appending start time in ms
			// to the end of the output filename.
			wsprintf(temp_time,L"_%I64d",read_start_time);
			wcscat_s(to,_MAX_PATH,temp_time);
			// If the output file exists, rename it before the copy
			rc = _wstati64(to,&statbuf_temp);
			for (trycount=0;trycount < 64 && rc==0; ++ trycount) {
				// file found, try a different name
				timenow = timeGetTime();
				wsprintf(temp_time,L"_%I64d",timenow);
				wcscpy_s(to,_MAX_PATH, toIN);
				rc = _wstati64(to,&statbuf_temp);
			}
			if (rc==0) {
				printf("Safe Copy Failed.  Unable to create temporary output file\n");
				if (logfi)
					fprintf(logfi,"Safe Copy Failed.  Unable to create temporary output file\n");
				return 2;
			}
			else
				rc = 0; // reset rc to no errors
		}
	}	
	wcscpy_s(fromU,_MAX_PATH,L"Copying ");
	wcscat_s(fromU,_MAX_PATH,from);

	if (useCopyFile && !colon && id==0) {
		BOOL Cancel = FALSE;
		copy_start = time(&copy_start);
		
		rc = CopyFileEx(from, to, CopyProgressRoutine, fromU, &Cancel, restart ? COPY_FILE_RESTARTABLE : 0);
		if (rc == 0) {
			errnbr = GetLastError();
			FormatMessage( 
				FORMAT_MESSAGE_ALLOCATE_BUFFER | 
				FORMAT_MESSAGE_FROM_SYSTEM | 
				FORMAT_MESSAGE_IGNORE_INSERTS,
				NULL,
				(DWORD) errnbr,
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
				(LPTSTR) &lpMsgBuf,
				0,
				NULL 
			);
			printf("\n%ls ===> %ls : %s\n",from,to,lpMsgBuf);
//			printf("\b\b\b : %s\n",lpMsgBuf);
			if (wcscmp(to,toIN)) {
				// Copy failed and output file was written to a temp name, delete it
				rc = _wstati64(to,&statbuf_out);
				if (rc == 0) {
					// Output file was created, delete it
					_wunlink(to);
				}
			}
			return 8;
		}
		copy_end = time(&copy_end);
		rc = _wstati64(to,&statbuf);
		if (timeit && id==0) {
			copy_time = copy_end - copy_start;
			if (copy_time <= 0)
				copy_time = 1;
			if (!quiet)
				printf(" (%ld bytes/sec)",
				statbuf.st_size/copy_time);
			if (logfi)
				fprintf(logfi," (%ld bytes copied in %ld seconds at %ld bytes/second) ",
				statbuf.st_size,copy_end - copy_start, statbuf.st_size/copy_time);
		}
		// If we made a backup of the original output file, delete it now
		if (rc)
			errnbr = errno;
		else
			errnbr = 0;
		Sleep(0);			// Give up rest of timeslice after each file
		return rc;
	}

	if (rcin = _wsopen_s(&in,from,O_BINARY|O_RDONLY,SH_DENYWR,_S_IREAD))
		// Can't open file, locked for writing
		if (rcin = _wsopen_s(&in,from,O_BINARY|O_RDONLY,SH_DENYNO, _S_IREAD)) {
			// Can't open file at all
			errnbr = errno;
			return 1;
		}
	// input file is open, in contains file handle
	openflags = O_BINARY|O_TRUNC|O_CREAT|O_WRONLY;
	if (copytoend && oc==0)
		openflags = O_BINARY|O_APPEND|O_CREAT|O_RDWR;
	if (restart) {
		// If restarting, open the output file for append
		if (_wsopen_s(&out,to,O_BINARY|O_APPEND|O_CREAT|O_RDWR,SH_DENYWR,_S_IREAD|_S_IWRITE)) {
			// open failed.  Close input file and quit.
			_close(in);
			errnbr = errno;
			return 2;
		}
		else {
			// open succeeded.  
			filelen = _filelengthi64(out); 
			/* grab the size of the existing output file */
			if (filelen == -1) {
				errnbr = errno;
				_close(in);
				return 2;
			}
			/* position the input file to the length of the output file */
			if (_lseeki64(in,filelen,SEEK_SET) == -1) {
				errnbr = errno;
				_close(in);
				return 2;
			}
		}
	}
	
	
	else  {
		// Open output file and position to the end of file
		if (_wsopen_s(&out,to,openflags, SH_DENYRW,S_IREAD|S_IWRITE)) {
			fprintf(stderr,"%ls: Unable to Open output file",to);
			perror("");
			errnbr = errno;
			_close(in);
			return 2;
		}
	}
	

	copy_start = time(&copy_start);
	fromtime.actime = a_time;
	fromtime.modtime= m_time;
	ln = buflen;
	k = 0;


	time_set = 0;
	
	while (ln == buflen) {
		/* Read in file and twirl baton */
        /* if the verify option is on, then grab position of the file */
        /* before each read.  Note verify option forces only 1 block */
        /* so that most of the fancy code below is not needed */
		verified = 0;
        current_record = _lseek(in,0l,SEEK_CUR);
		for (vkt=1;vkt<=10 && !verified;++vkt) {
			/* read a buffer full of information */
			/* if verification (vfile != NULL), then nbufs is set to 1 */
			/* otherwise attempt to read as much into program as you */
			/* have room for */
			if (!time_set) {
				time_set = 1;
				read_start_time = timeGetTime();
				write_start_time = read_start_time;
			}
			for (k=0;k <= nbufs && ln == buflen;++k) {
				ln = _read(in,bufptr[k],buflen);
				if (!batch)
                    spindial();
             	/* keep reading until the entire buffer has been read
				and error has occurred or endoffile. */
				if (ln > 0 && ln < buflen) {
					bptr = bufptr[k];
					blen = buflen;
					for (l=ln;l > 0 && ln < buflen; ln += l) {
						bptr += l;
						blen -= l;
						l = _read(in,bptr,blen);
                        if (!batch)
                            spindial();
					}
					if (l == -1)
						ln = (unsigned)(-1);
				}
				read_end_time = timeGetTime();
				if (input_pacing) 
					// determine if we need to sleep
					if ((int)(read_end_time - read_start_time) < (int)input_pacing_interval)
						Sleep(input_pacing_interval - read_end_time + read_start_time);
					else
						;
				else
					Sleep(0); // give up time slice
				read_start_time = timeGetTime();
			}
			/* A buffer has been read, if any errors have occurred, bye */
			if (ln == -1) {
				if (!quiet)
					fprintf(stderr,"Reading buffer %d at %8x length %u\n",k,bufptr[k],buflen);
				if (logfi)
					fprintf(logfi,"Reading buffer %d at %8x length %u\n",k,bufptr[k],buflen);
				/* Read Error */
				rc = 3;
				break;
			}
#ifdef VERIFYCRC			
			/* If no verification file, now done */
			if (vfile == NULL)
				verified = 1;
			else {
				/* Need to verify data just read.  CRCs have been calculated */
				/* The blocksize used is a multiple of the CRC block length */
				/* Should be exactly n blocks of size atoi(vblock); verify */
				char c16[255];
				verified = 1;
				ln1 = vblksi;
				for (o=0;o < ln  && verified;o+=ln1) {
					if ((ln - o) < ln1)
						ln1 = ln - o;
					crc16 = updcrc((unsigned)(0xFFFF),bufptr[0]+o,ln1);
					fgetws(vcrc16,10,vfile);
					wcstombs(c16,vcrc16,10);
					if (crc16 == (unsigned)(atol(c16)))
						verified = 1;
                	else {
						verified = 0; /* break out of the loop and reread */
                    	lseek(in,current_record,SEEK_SET);
                    	++errkt;
					}                  
                }
			}
#else
			verified = 1;
#endif
			/* At this point either the block has been verified, (Verify == 1) */
			/* or verification has failed (verify == 0) */
			/* If verify == 1, then we skip past the next loop and read in */
			/* the next block.  If verify == 0, we have used lseek to move */
			/* the read pointer back to the position of the block and we */
			/* reread.  We may actually be rereading more data than we need */
			/* to, but we expect a very low incidence of failure, so it */
			/* shouldn't matter much */
		}

		/* A verified block of data has been read */
		/* if any errors have occurred, done ; otherwise write out block */
		if (rc)
			break;

		if (!verified) {
			rc = 5; /* Verify Error */
			break;
		}

		/* Write out file and twirl baton */
		for (lo=buflen,i=0;i < k-1 && lo == buflen;++i) {
			lo = _write(out,bufptr[i],(unsigned)(buflen));
			write_end_time = timeGetTime();
            if (!batch) {
                spindial();
                filelen = _filelengthi64(out);
                pct = (filelen*100)/filelen2;
                if (pct > ppct) {
					if (!quiet) {
						printf("\b\b\b%2I64d%c",pct,'%');
						if (ProgressBar == -1)
							if (pct < 3) 
								ProgressBar = ShowProgressBar(fromU);
							else
								ProgressBar = 0;
						if (ProgressBar == 1)
							SendMessage(hwndPB, PBM_SETPOS, (WPARAM) pct, 0); 
					}
                    ppct = pct;
                }
            }
			/* If lo < buflen, a partial block has been written
			keep trying until either no more bytes are written
			and error occurs or the buffer has been written */
			if (lo > 0 && lo < buflen) {
				bptr = bufptr[i];
				blen = buflen;
				for (l=lo; l > 0 && lo < buflen; lo += l) {
					bptr += l;
					blen -= l;
					l = _write(out,bptr,blen);
                    if (!batch)
                        spindial();
				}
				if (l == -1) {
					errnbr = errno;
					lo = (unsigned)(-1);
				}
			}
			if (output_pacing)
				if ((int)(write_end_time - write_start_time) < (int)output_pacing_interval)
					Sleep(output_pacing_interval - write_end_time + write_start_time);
				else
					;
			else
				Sleep(0); // give up timeslice
			write_start_time = timeGetTime();
		}

		if (lo == -1) {
			/* Write Error */
			rc = 4;
			break;
		}

		if (ln) {
			/* Write out any unwritten data */
			lo=_write(out,bufptr[i],ln);
			if (lo > 0 && lo < ln) {
				bptr = bufptr[i];
				blen = ln;
				for (l=lo; l > 0 && lo < ln; lo += l) {
					bptr += l;
					blen -= l;
					l = _write(out,bptr,blen);
				}
				if (l == -1) {
					errnbr = errno;
					lo = (unsigned)(-1);
				}
			}
			if (lo == -1) {
				errnbr = errno;
				rc = 4;
				break;
			}
		}
		if (!batch) {
			spindial();
			filelen = _filelengthi64(out);
			pct = (int)((filelen*100)/filelen2);            
			if (pct > ppct) {
				if (!quiet) {
               		printf("\b\b\b%2d%c",pct,'%');
					if (ProgressBar == 1)
						SendMessage(hwndPB, PBM_SETSTEP, (WPARAM) pct, 0); 
				}
               	ppct = pct;
            }                                                        	
		}
	}
	copy_end = time(&copy_end);
	if (!batch && !quiet)
		printf("\b\b\b\b");
	_close(in);
	filelen=_filelengthi64(out);
	_close(out);

	if (wcscmp(to,toIN)) {
		// Written to a temporary file
		if (rc) {
			// An error occurred and the output file was given a temp name
			// delete it			// Copy failed and output file was renamed, name it back
			if (_wstati64(to,&statbuf_out) == 0) {
				// Output file was created, delete it
				_wunlink(to);
			}
		}
		else {
			// Copy was good, delete the original file and rename the backup
			if (_wstati64(toIN,&statbuf_out) == 0) 
				// Delete original file
				_wunlink(toIN);
			_wrename(to,toIN); 
		}			
	}
	if (rc == 0) {
		errnbr = 0;
		_wutime(toIN,&fromtime); // Only set filetime if copy was successful
	}
	if (set_hiddensystem) {
		attributes = GetFileAttributes(from);
		SetFileAttributes(to,attributes|FILE_ATTRIBUTE_ARCHIVE);
	}
	if (input_pacing || output_pacing || timeit) {
		copy_time = copy_end - copy_start;
		if (copy_time <= 0)
			copy_time = 1;
		if (!quiet)
			printf(" (%ld bytes/sec)",
		filelen/copy_time);
		if (logfi)
			fprintf(logfi," (%ld bytes copied in %ld seconds at %ld bytes/second) ",
			filelen,copy_end - copy_start, filelen/copy_time);
	}
	if (ProgressBar == 1)
		KillProgressBar();
	Sleep(0);	// give up timeslice to not hog machine

	return rc;
}

void p_error(int err, wchar_t *fromfull, wchar_t *tofull) {
	int er;
	PVOID *lpMsgBuf;
	char msg[1024];
	
	
	_strerror_s(msg,1024,"");
	er = errnbr;
	if (!quiet) printf("%ls ===> %ls",fromfull,tofull);
	if (logfi) fprintf(logfi,"%ls ===> %ls",fromfull,tofull);
	switch(err) {
	case 1: 
		if (!quiet) printf(" : Unable to open input.  %s\n",msg);  
		if (logfi)	fprintf(logfi," : Unable to open input.  %s\n",msg);
		break;
	case 2: 
		if (!quiet)	printf(" : Unable to open output.  %s\n",msg);
		if (logfi)	fprintf(logfi," : Unable to open output.  %s\n",msg);
		break;
	case 3: 
		if (!quiet)	printf(" : Read error.  %s\n",msg);
		if (logfi)	fprintf(logfi," : Read error.  %s\n",msg);
		break;
	case 4: 
		if (!quiet)	printf(" : Write error.   %s\n",msg);
		if (logfi)	fprintf(logfi," : Write error.  %s\n",msg);
		break;
	case 5:
		if (!quiet)	printf(" : Verify error at offset %ld. \n ",current_record);
		if (logfi)	fprintf(logfi," : Verify error at offset %ld.\n",current_record);
		break;
	case 6:
		if (!quiet)	puts(" : Source, Destination are same file.\n");
		if (logfi)	fprintf(logfi," : Source, Destination are same file.\n");
		break;
	case 7:
		if (!quiet)	puts(" : Failed.  Can not archive to a stream.\n");
		if (logfi)	fprintf(logfi," : Failed.  Can not archive to a stream.");
		break;
	default:
		FormatMessage( 
				FORMAT_MESSAGE_ALLOCATE_BUFFER | 
				FORMAT_MESSAGE_FROM_SYSTEM | 
				FORMAT_MESSAGE_IGNORE_INSERTS,
				NULL,
				(DWORD) errnbr,
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
				(LPTSTR) &lpMsgBuf,
				0,
				NULL 
			);
		if (!quiet)	printf(" : Error %d %d %ls\n",err,errnbr,lpMsgBuf);
		if (logfi)	fprintf(logfi," : Error %d %d %ls\n",err,errnbr,lpMsgBuf);

		break;
	}
//	if (err < 5 && !quiet)
//	   perror("");
	rc = 1;
}

int mk_all_dir(wchar_t *path_buffer) {
	TCHAR drive[_MAX_DRIVE];
	TCHAR dir[_MAX_DIR];
	wchar_t fname[_MAX_FNAME];
	wchar_t ext[_MAX_EXT];
	wchar_t new_level[_MAX_PATH];
	struct _stat dta;
	int k;
	k = wcslen(path_buffer) - 1;
	if (k > 0 && (path_buffer[k] == '\\' || path_buffer[k] == '/'))
		path_buffer[k] = 0;
	/*   printf("mk_all_dir: %s\n",path_buffer); */
	_wsplitpath_s( path_buffer, drive,_MAX_DRIVE, dir,_MAX_DIR, fname,_MAX_FNAME, ext,_MAX_EXT );
	_wmakepath_s( new_level,_MAX_PATH, drive, dir, L"",L"");
	/*   printf("\t%s\n",new_level); */
	if (wcscmp(dir,L"\\")==0 || wcscmp(dir,L"/")==0 || fname[0] == 0 ||
	    (_wstat(new_level,&dta) == 0 &&  (dta.st_mode & S_IFDIR)))
		;
	else
		mk_all_dir(new_level);
	return _wmkdir(path_buffer);
}

FILE *tofi;
int nextto;
int next_output(wchar_t *to_path,int argc,wchar_t *argv[]) {
	int l;
	char more = 1;
	while (more) {
		if (tofi) {
			/* reading from a file */
			if (fgetws(to_path,_MAX_PATH,tofi) == NULL) {
				/* End of File */
				fclose(tofi);
				tofi = NULL;
			}
			else { /* return next line of file */
				l = wcslen(to_path);
				if (*(to_path+l-1) == L'\n')
					*(to_path+l-1) = 0;
				return 1;
			}
		}
		if (nextto >= argc)
			return 0;
		wcscpy_s(to_path,_MAX_PATH,argv[nextto++]);
		if (*to_path == L'@') {
			if (_wfopen_s(&tofi,to_path+1,L"r"))
				return 1;
			if (tofi == NULL)
				return 1;
			/* assume to_path is a file or directory that begins with @ */
		}
		else
			return 1;
	}
	return 0;
}


wchar_t drive[_MAX_DRIVE];
wchar_t dir[_MAX_DIR];
wchar_t fname[_MAX_FNAME];
wchar_t ext[_MAX_EXT];

wchar_t *firstfi(long *path_handle, TCHAR *pathdir) {
int rc;

/* look for all files, including hidden and system */
/* return name of first file found that is not a sub-directory */
/* return name of a hidden-system file only if hiddensystem == 1 */
	_wsplitpath_s(pathdir,drive,_MAX_DRIVE,dir,_MAX_DIR,fname,_MAX_FNAME,ext,_MAX_EXT);

	for (rc=0,*path_handle=_wfindfirst(pathdir,&finddata);
		*path_handle != -1L && rc == 0;
	    rc=_wfindnext(*path_handle,&finddata)) {
		if (finddata.attrib & _A_SUBDIR)
			continue; // ignore subdirectories

		if (!hiddensystem && (finddata.attrib & 
		    (_A_HIDDEN|_A_SYSTEM)))
			continue;
		wcscpy_s(fname,_MAX_FNAME,finddata.name);
		_wmakepath_s(temp,_MAX_PATH,drive,dir,fname,L"");
		return temp;
	}
	/* Reached end of list without finding a matching file */
	if (rc == 0) // did not find even one candidate
		;
	else
		_findclose(*path_handle);  // Shut down find
	return filenotfound;  // not found, return empty name
}
		
wchar_t *nextfi(long path_handle) {
int rc;

/* look for all files, including hidden and system */
/* return name of first file found that is not a sub-directory */
/* return name of a hidden-system file only if hiddensystem == 1 */
	rc = 0;
	
	while ((rc=_wfindnext(path_handle,&finddata)) == 0) {
		if (finddata.attrib & _A_SUBDIR)
			continue; // ignore subdirectories

		if (!hiddensystem && (finddata.attrib & 
		    (_A_HIDDEN|_A_SYSTEM)))
			continue;
		_wmakepath_s(temp,_MAX_PATH,drive,dir,finddata.name,L"");
		return temp;
	}
	/* Reached end of list without finding a matching file */
	_findclose(path_handle);  // Shut down find
	return filenotfound;  // not found, return empty name
}



int next_input(wchar_t *from_path,int toidx,wchar_t *argv[],
			   int *wildcard,int *nextarg,FILE *fromfi) {
	char more = 1;
	int l;
	wchar_t temp[_MAX_PATH];
//	char searching_all = 0;

	while (more) {
		if (fromfi) {
			/* reading from a file */
			/* Note wildcards are not permitted within file */
			if (fgetws(from_path,_MAX_PATH,fromfi) == NULL) {
				/* End of File */
				fclose(fromfi);
				fromfi = NULL;
			}
			else {
				l = wcslen(from_path);
				if (*(from_path+l-1) == '\n')
					*(from_path+l-1) = 0;
				return 1;
			}
		}
		if (*wildcard) {
			/* getting next file from get next file */
			wcscpy_s(from_path,_MAX_PATH,nextfi(path_handle));
			if (*from_path)
				return 1;
			*wildcard = 0;
		}
		if (*nextarg >= toidx)
			return 0;
		wcscpy_s(from_path,_MAX_PATH,argv[*nextarg]);
		*nextarg = *nextarg + 1;
		if (*from_path == '@') {
			
			if (_wfopen_s(&fromfi,from_path+1,L"r") || fromfi == NULL) {
				/* attempted to open file of input names, but can't */
				/* check to see if a file or directory exists with that */
				/* name.  If so, then return name, otherwise try next file */
				if (is_dir(from_path))
					/* fromfi is a file or directory that begins with @ */
					return 1;
				if (!quiet)
					printf("%ls: Unable to open response file\n",from_path+1);
				if (logfi)
					fprintf(logfi,"%ls: Unable to open response file\n",from_path+1);
			}
		}
		else if (wcschr(from_path,L'*') == NULL && wcschr(from_path,L'?') == NULL)
			return 1;
		else { // Wildcard characters present, do a directory search
			*wildcard = 1;
			/* Change this code so that you get the first matching
			   file in wildcard search.  If no matching files,
			   loop and look at next file in the list */
			wcscpy_s(temp,_MAX_PATH,firstfi(&path_handle,from_path));
			if (*temp) {
				wcscpy_s(from_path,_MAX_PATH,temp);
				return 1;  /* found one, otherwise try again */
			}
			*wildcard = 0; /* no longer in wildcard path */
			/* As best I can tell, ? and * are not allowed in file names */
			/* however [ and ] are allowed, therefore this program can */
			/* not use Unix style matches for copying files */
		}
	}
	return 0;
}


void Usage(void) {
	FILE *hlp;
	char tmp[_MAX_PATH];
	char cmd[_MAX_PATH];
	WCHAR wtmp[_MAX_PATH],*wp;
	size_t wplen;

	if (_wdupenv_s(&wp,&wplen,L"tmp") || wp==NULL)
		if (_wdupenv_s(&wp,&wplen,L"temp") || wp == NULL)
			GetWindowsDirectory(wtmp,_MAX_PATH);
		else
			wcscpy_s(wtmp,_MAX_PATH,wp);
	else
		wcscpy_s(wtmp,_MAX_PATH,wp);
	if (wtmp[wcslen(wtmp)-1] != L'\\')
		wcscat_s(wtmp,_MAX_PATH,L"\\");

	wcscat_s(wtmp,_MAX_PATH,L"cp32.hlp");
	_wfopen_s(&hlp,wtmp,L"w");

	fprintf(hlp,"CP32 4.38 -- %s for ",__DATE__);
	fprintf(hlp,"32 bit Windows, supporting long file names.\n");
	fprintf(hlp,"\nCopywrite 2003-2009, Norm London, London Computing.\nnorm_london@londoncomputing.com\n\n");
	fprintf(hlp,"This program is free software; you can redistribute it and/or modify\n");
	fprintf(hlp,"it under the terms of the GNU General Public License as published by\n");
	fprintf(hlp,"the Free Software Foundation; either version 2 of the License, or\n");
	fprintf(hlp,"(at your option) any later version.\n\n");
	fprintf(hlp,"This program is distributed in the hope that it will be useful,\n");
	fprintf(hlp,"but WITHOUT ANY WARRANTY; without even the implied warranty of\n");
	fprintf(hlp,"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n");
	fprintf(hlp,"GNU General Public License for more details.\n\n");
	fprintf(hlp,"You should have received a copy of the GNU General Public License\n");
	fprintf(hlp,"along with this program; if not, write to the Free Software\n");
	fprintf(hlp,"Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n\n");
	fprintf(hlp,"Written by London Computing, PO Box 696, Cherry Hill, NJ 08003.\n\n");
	fprintf(hlp,"Usage is:\n cp32 [flags] src1 [src2 ...] target -or-\n");
	fprintf(hlp," cp32 [flags] src1 [src2 ...] -to target1 [target2...]\n\n");
	fprintf(hlp,"Copies source files to target. If only one source file is present, the target\n");
	fprintf(hlp,"may be a file or directory. If more than one source file is present, the target\n");
	fprintf(hlp,"must be a directory. A source file name may include the wildcard characters\n");
	fprintf(hlp,"* and ?.  If a target ends with a \\ or /, it is assumed to be a directory\n");
	fprintf(hlp,"name. If more than one source file is present and the target directory does\n");
	fprintf(hlp,"not exist, a directory will be be created.   NEW -S flag copies subdirectories.\n");
	fprintf(hlp,"Existing files are overwritten. \n\n");
	fprintf(hlp,"If the -to flag is used, multiple targets are allowed.  If the -to flag is\n");
	fprintf(hlp,"is omitted, the last entry on the command line is assumed to be the target.\n");
	fprintf(hlp,"If wildcards are used and the target is accidently omitted, the last source\n");
	fprintf(hlp,"will be used as the target and may be overwritten.\n\n");
	fprintf(hlp,"If any target begins with an @, it is assumed to be a response file which\n");
	fprintf(hlp,"contains a list of targets, 1 to a line.  If the response files do not\n");
	fprintf(hlp,"exist, the source or target is assumed to be a file name or directory name.\n");
	fprintf(hlp,"\nWarning -- CP32 will not work properly with files larger than 2GB.\n");
	fprintf(hlp,"\n");
	fprintf(hlp,"\nFlags:\n");
	fprintf(hlp,"[{-c[r]|-n[r]|-w[r]|-r}] [-m] [-b] [-kn] [-p[r] [-q] \n");
#ifdef VERIFYCRC
	fprintf(hlp,"[{-in[K]/s | -on[K]/s}] [{-llogfi | -Llogfi}] [-vcrcfile] [-t] [-f]\n");
#else
	fprintf(hlp,"[{-in[K]/s | -on[K]/s}] [{-llogfi | -Llogfi}] [-t] [-f] [-l-]\n");
#endif
	fprintf(hlp,"-r       -- replace existing files only.  Unconditional Replacement.\n");
	fprintf(hlp,"-w       -- copy files that either have newer Windows Versions or if the versions\n");
	fprintf(hlp,"            are the same, then have newer file dates than the receiving files\n");
	fprintf(hlp,"            or do not exist in the receiving directory.\n");
	fprintf(hlp,"-wx      -- Same as -w above, but assume that two files have the same modification time\n");
	fprintf(hlp,"            if the difference in modification times is <=x seconds (default is 0 seconds\n");
	fprintf(hlp,"-n  --      copy files that are newer than receiving file, -or- do not exist\n");
	fprintf(hlp,"-nx      -- Same as -n above, but assume that two files have the same modification time\n");
	fprintf(hlp,"            if the difference in modification times is <=x seconds (default is 0 seconds\n");
	fprintf(hlp,"-c  --      copy changed files, i.e. those files where either the file\n");
	fprintf(hlp,"            modification time, file size or file version of the source \n");
	fprintf(hlp,"            file is different from the destination or where files exist\n");
	fprintf(hlp,"            in the source but not the destination.\n");
	fprintf(hlp,"            File modification times are considered equal if they are within\n");
	fprintf(hlp,"            two seconds of each other in order to work around differences \n");
	fprintf(hlp,"            in the way times are stored on the FAT and NTFS file systems.\n");
	fprintf(hlp,"-cx      -- Same as -c above, but assume that two files have the same modification time\n");
	fprintf(hlp,"            if the difference in modification times is <=x seconds (default is 0 seconds\n");
	fprintf(hlp,"-wr      -- Like -w, but the file must exist in the receiving directory.\n");
	fprintf(hlp,"-nr      -- copy only files that are newer than existing files.\n");
	fprintf(hlp,"-cr      -- copy only files that are changed.\n");
	fprintf(hlp,"-o       -- Overwrite output files even if marked as READ ONLY.\n");
	fprintf(hlp,"-os      -- Safe Overwrite.  Copy the file with a temporary name.  If the copy is successful,\n");
	fprintf(hlp,"            delete the original output file and rename the temporary file to the new name.\n");
	fprintf(hlp,"-e       -- Copytoend.  Append the source file to the end of the destination file.\n");
	fprintf(hlp,"-b       -- Batch mode.  Use when redirecting output.  Forces all messages\n");
	fprintf(hlp,"            to stdout and omits spinning bars during copy.\n");
	fprintf(hlp,"-m       -- Move source to destination, i.e. delete source files after copy.  Leaves the\n");
	fprintf(hlp,"			 directory structure intact.  (Does not delete empty directories).\n");
	fprintf(hlp,"-kn      -- n < 64 -- Set a blocksize of nKB; n < 1024 set a blocksize of n bytes.\n");
	fprintf(hlp,"            Default is 65024 bytes.  Smaller block sizes should be used if you \n");
	fprintf(hlp,"            time out on WAN copies.\n");
	fprintf(hlp,"-p       -- Take checkpoints during the copy.  This forces a write to disk after\n");
	fprintf(hlp,"            every block.  This option slows the copy, use for WAN copies only.\n");
	fprintf(hlp,"-pr      -- Take checkpoints as above.  If the target file exists, do a restart,\n");
	fprintf(hlp,"            ie., add missing data to the end of the existing target.\n");
	fprintf(hlp,"-Llogfi  -- Log all copy results to the logfi.  Create a second file named\n");
	fprintf(hlp,"            logfi.fil that contains a list of all of the files that were\n");
	fprintf(hlp,"            successfully copied.  If logfi exists, then the log is appended.\n");
	fprintf(hlp,"            If logfi.fil exists, it is replaced.\n");
	fprintf(hlp,"-llogfi  -- Log all copy results to the logfi.  Do not create file list.\n");
	fprintf(hlp,"            If logfi exists, the new log is appended to logfi.\n");
	fprintf(hlp,"-l-         Do not log files that were not copied because they were up to date.\n");
	fprintf(hlp,"-a		  -- Archive existing files while preserving file extention. If the \n");
	fprintf(hlp,"			 destination file already exists, it is renamed before the copy.  \n");
	fprintf(hlp,"		     This places a .(-01). in front of the file extention.  Earlier\n");
	fprintf(hlp,"            versions are renamed so that the next version has .(-02). \n");
	fprintf(hlp,"            before the file extention.  By default, 5 versions of the file will\n");
	fprintf(hlp,"            be kept, but that can be overridden by the -g or -G flags.\n");
	fprintf(hlp,"            You can use the -a flag to save a backup copy of a file or group of\n");
	fprintf(hlp,"            files before changing them by running: CP32 -a filename [filename...] -to .\n");
	fprintf(hlp,"            -a can only be used when the destination is a file.  If you specify\n");
	fprintf(hlp,"            a stream instead of a file, CP32 will not copy.\n");
	fprintf(hlp,"            a stream instead of a file, CP32 will not copy.\n");
	fprintf(hlp,"-gn      -- n <= 99.  Save n generations of the file in the target directory.\n");
	fprintf(hlp,"            If you lower the number of generations in subsequent calls to,\n");
	fprintf(hlp,"            archive, older generations will not be deleted. If set, -A assumed.\n"); 
	fprintf(hlp,"            -G can only be used when the destination is a file.  If you specify\n");
	fprintf(hlp,"            a stream instead of a file, CP32 will not copy.\n");
	fprintf(hlp,"-in[K]/s -- Pace input to n (or nKB) bytes every s seconds.\n");
	fprintf(hlp,"            Example: -i10K/2 <=== Pace to 10KB every 2 seconds.\n");
	fprintf(hlp,"-on[K]/s -- Pace output to n (or nKB) bytes every s seconds.\n");
	fprintf(hlp,"            You may specified either Input pacing or Output pacing, not both.\n");
	fprintf(hlp,"            Example: -o100K/10 <=== Pace to 100KB every 10 seconds.\n");
	fprintf(hlp,"-Q       -- Quiet Mode.  Does not display status information.\n");
	fprintf(hlp,"            If omitted, a banner displays when the program starts \n");
	fprintf(hlp,"            and Copy progress is reported as CP32 runs.  The percentage\n");
	fprintf(hlp,"            copied will be displayed in the console window.  If a \n");
	fprintf(hlp,"            large copy is performed, a GUI progress window will open.\n");
	fprintf(hlp,"-h       -- Copy hidden/system files when doing a wildcard copy.\n");
	fprintf(hlp,"            Hidden/System attributes will NOT be set by copy.\n");
	fprintf(hlp,"-h+      -- Copy hidden/system files.  Set attributes.\n");
	fprintf(hlp,"-s       -- Copy subdirectories recursively, source must be a directory.\n");
	fprintf(hlp,"-sv      -- Copy as above, verbose mode.  Echo each directory being scanned.\n");
	fprintf(hlp,"-t       -- Time the copy and write statistics to stdout.\n");
	fprintf(hlp,"-f       -- Move all forks(streams) in a file.  Windows 32 Only.  Uses the \n");
	fprintf(hlp,"            CopyFileEx API.  When -f is specified the Input Pacing, Output Pacing, \n");
	fprintf(hlp,"            Verify and BlockSize options are not available.  Attributes of the output \n");
	fprintf(hlp,"            file will be set to the attributes of the input file.\n");
	fprintf(hlp,"-id      -- Identify files to be copied, but don't copy files.  Use with -c or -n.\n");
	fprintf(hlp,"-x \"f1..\"-- List of filenames to exclude.  Wildcard characters can be used.\n");
	fprintf(hlp,"            The list should be enclosed in quotes.  If multiple files are listed,\n");
	fprintf(hlp,"            separate each file name with a semicolon.  Use a forward slash (/) \n");
	fprintf(hlp,"            instead of a backslash (\\) as the directory seperator. \n");
	fprintf(hlp,"            Examples -x=\"*.exe;*/abc/*\" will exclude exe files and any files in \n");
	fprintf(hlp,"            directory abc from the copy.\n");
#ifdef VERIFYCRC
	fprintf(hlp,"\n-vcrcfile -- crcfile is path name of a verification file.  Use program\n");
	fprintf(hlp,"       CRC16V.EXE to build a verification file.  The file is used to\n");
	fprintf(hlp,"       validate the source files as it is copied to the target.  When \n");
	fprintf(hlp,"       CRC16V is run, it calculates a CRC code for each 2000 byte section\n");
	fprintf(hlp,"       of a file.  These CRCs are stored in the verification file.\n\n");
	fprintf(hlp,"       When -v is specified, checkpoint is set on.  Each time a block is read,\n");
	fprintf(hlp,"       a CRC is calculated and compared against the value in the verification.\n");
	fprintf(hlp,"       file.  CP retries up to 10 times when a block doesn't validate.\n");
	fprintf(hlp,"       The copy is terminated after 10 failures.\n\n");
	fprintf(hlp,"       Use the -v option only when doing WAN transfers.  CRC16V should be\n");
	fprintf(hlp,"       run on a machine at the site of the source file.  CP should be run\n");
	fprintf(hlp,"       on a machine at the site of the destination filed.\n");
#endif
	fprintf(hlp,"\nCP32 continues working if short blocks are read or written.  Short blocks\n");
	fprintf(hlp,"are sometimes caused by timeouts when copying accross a WAN.  CP32 supports\n");
	fprintf(hlp,"WAN copying.\n\n");
	fprintf(hlp,"Returns ERROR LEVEL 0--All files copied; else some files did not copy.\n\n\n\n");
	close_log_files();
	fclose(hlp);
	strcpy_s(cmd,_MAX_PATH,"NOTEPAD.EXE ");
	sprintf_s(tmp,_MAX_PATH,"%ls",wtmp);
	strcat_s(cmd,_MAX_PATH,tmp);
	WinExec(cmd,SW_SHOW);


	exit(8);
}


					
int DestIsNewer(wchar_t *from_path, wchar_t *toname) {
	// Return Code: 0 -- Copy files; 1 -- Do not copy files
	// dta structure has stat info from source
	// dta1 structure has stat info from destination
	// from_version has version info from source
	// to_version has version info from destination
	// Return 1 if Destination is Newer version, date or Same
	// Return 0 if Destination is older
	// If wnew flag set, first compare versions.  If versions 
	// are the same compare dates.

	if (wnew) {
		/* if testing windows versions, compare */
		/* receiving file (to_) should have a lower version */
		/* than sending file (from_) */
		if (to_version[0] > from_version[0]) {
			if (logfi) {
				fprintf(logfi,"%ls ===> %ls",from_path,toname);
				fprintf(logfi," : Destination has newer version.\n");
			}
			return 1;  // Do not copy files
		}

		if (to_version[0] < from_version[0]) {
			if (logfi && logall) {
				fprintf(logfi,"%ls ===> %ls",from_path,toname);
				fprintf(logfi," : Destination has older version.\n");
			}
			return 0; // Copy files
		}

		// High Version Info is the Same
		if (to_version[1] > from_version[1]) {
			if (logfi && logall) {
				fprintf(logfi,"%ls ===> %ls",from_path,toname);
				fprintf(logfi," : Destination has newer version.\n");
			}
			return 1; // Do not copy files
		}
	
		if (to_version[1] < from_version[1]) {
			if (logfi && logall) {
				fprintf(logfi,"%ls ===> %ls",from_path,toname);
				fprintf(logfi," : Destination has older version.\n");
			}
			return 0; // Copy files
		}

		/* Version Numbers are present, but the same, */
		/* check dates */

		// if ((to_version[0]||to_version[1])&&(from_version[0]||from_version[1]))
		//	return 0;

		// assume equal times are any times within timespan
		if ((dta.st_mtime - dta1.st_mtime) <= (__time64_t)timespan) {
			if (logfi && logall) {
				if (_abs64(dta.st_mtime - dta1.st_mtime) <= (__time64_t)timespan) {
					fprintf(logfi,"%ls ===> %ls",from_path,toname);
					fprintf(logfi," : Up to Date.\n");
				}
				else {
					fprintf(logfi,"%ls ===> %ls",from_path,toname);
					fprintf(logfi," : Destination is newer.\n");
				}
			}
			return 1; // Return 1 means DO NOT COPY
		}
		if (logfi && logall) {
			fprintf(logfi,"%ls ===> %ls",from_path,toname);
			fprintf(logfi," : Destination is older.\n");
		}
		return 0; // Copy files
	}
		
	// Don't check version info, just check time date stamps 
	// assume equal times are any times within timespan
	if ((dta.st_mtime - dta1.st_mtime) <= timespan) {
		if (logfi && logall) {
			// this should test for equality within timespan seconds
			if (_abs64(dta.st_mtime - dta1.st_mtime) <= (__time64_t)timespan)
				fprintf(logfi,"%ls ===> %ls : Up to Date.\n",from_path,toname);
			else {
				fprintf(logfi,"%ls ===> %ls",from_path,toname);
				fprintf(logfi," : Destination is newer.\n");
			}
		}
		return 1; // Do NOT COPY
	}
	if (logfi && logall) {
		fprintf(logfi,"%ls ===> %ls",from_path,toname);
		fprintf(logfi," : Destination is older.\n");
	}
	return 0;
}


int badVerificationFile(FILE *vfile,wchar_t *mtime,wchar_t *vctime,_int64 size,long vsize) {
	if (vfile == NULL) // No verification file
		return 0;
	
	if (wcscmp(mtime,vctime) == 0 && size == vsize)
		return 0; /* file has not changed */

	//whoops
	if (!quiet) {
		fprintf(stderr, "Invalid verification file!\n");
		if (wcscmp(mtime,vctime)) {
			fprintf(stderr,"The file has changed since the verification file was created.\n");
			fprintf(stderr,"The file was last modified on  %ls",mtime);
			fprintf(stderr,"The verification file expected %ls",vctime);
		}
		if (size != vsize) {
			fprintf(stderr,"The file has changed in size since the verification files was created.\n");
			fprintf(stderr,"The file size is %ld bytes.  A size of %ld bytes was expected.\n",size,vsize);
		}
	}
	if (logfi) {
		char ctimebuf[_MAX_PATH];
		ctime_s(ctimebuf,_MAX_PATH,&dta.st_mtime);
		fprintf(logfi, "Invalid verification file!\n");
		if (wcscmp(mtime,vctime)) {
			fprintf(logfi,"The file has changed since the verification file was created.\n");
			fprintf(logfi,"The file was last modified on  %s",ctimebuf);
			fprintf(logfi,"The verification file expected %s",vctime);
		}
		if (size != vsize) {
			fprintf(logfi,"The file has changed in size since the verification files was created.\n");
			fprintf(logfi,"The file size is %ld bytes.  A size of %ld bytes was expected.\n",size,vsize);
		}
	}
	return 1;
}


void set_flags(int argc,wchar_t *argv[]) {
	int i,o,ln, offset = 0;
	int rc, mpy = 1;
	wchar_t *slash,temp[_MAX_DIR],*val;
	time_t logtime;

	vblksi = 0;
    rc = 0;
	for (start=1;start < argc && (argv[start][0] == '-' || argv[start][0] == '/');++start) {
		switch(towupper(argv[start][1])) {
		/* ABCDEGHIKLMNOPQRSVWX */

		case 'A':	// Archive up to 4 previous generations of this file.
			if (copytoend) {
				if (!quiet)
					fprintf(stderr,"Can not use -E (copy to end) in conjunction with \nthe -A (archive) flag.\n");
				if (logfi)
					fprintf(logfi,"Can not use -E (copy to end) in conjunction with \nthe -A (archive) flag.\n");
				rc = 1;
				break;
			}
			archive = 1;
			break;

		case 'B':	// Batch mode, don't display progress bars or twirling cursor
			batch = 1;
			break;

		case 'C':	// Only move changed files
			changed = 1;
			if (towupper(argv[start][2]) == L'R')
				repl = 1;
			else 
				if (_wtoi(argv[start]+2) > 0)
					timespan = _wtoi(argv[start]+2);
			break;

		case 'D': // Debug mode, not documented, for development only
			debug = 1;
			break;

		case 'E': // Append source file to End of destination file
			if (useCopyFile == 1) {
				if (!quiet)
					fprintf(stderr,"Can not use -E (Copy to end) in conjunction with -F (Copy Forks).\n");
				if (logfi)
					fprintf(logfi,"Can not use -E (Copy to end) in conjunction with -F (Copy Forks).\n");
				rc = 1;
				break;
			}
			copytoend = 1;
			break;

		case 'F': // Copy Forks.  Uses OS CopyFile program  Certain CP32 functions not available
			if (copytoend == 1) {
				if (!quiet)
					fprintf(stderr,"Can not use -E (Copy to end) in conjunction with -F (Copy Forks).\n");
				if (logfi)
					fprintf(stderr,"Can not use -E (Copy to end) in conjunction with -F (Copy Forks).\n");
				rc = 1;
				break;
			}
			useCopyFile = 1;
			break;

		case 'G': // -Gnn:  save last n generations of this file, like -A
			if (copytoend) {
				if (!quiet)
					fprintf(stderr,"Can not use -E (copy to end) in conjunction with \nthe -G (archive) flag.\n");
				if (logfi)
					fprintf(logfi,"Can not use -E (copy to end) in conjunction with \nthe -G (archive) flag.\n");
				rc = 1;
				break;
			}
			versions = _wtoi(argv[start]+2);
			archive = 1; /* If G flag, then assume A flag */
			if (versions <= 0) {
				versions = 5;
				if (!quiet)
					fprintf(stderr,"%s Invalid.  5 generations will be saved.\n",argv[start]);
				if (logfi)
					fprintf(logfi,"%s Invalid.  5 generations will be saved.\n",argv[start]);
			}
			if (versions > 99) {
				versions = 99;
				if (!quiet)
					fprintf(stderr,"%s Invalid.  99 generations will be saved.\n",argv[start]);
				if (logfi)
					fprintf(logfi,"%s Invalid.  99 generations will be saved.\n",argv[start]);
			}
			break;

		case 'H':  // Copy hidden and system files, use with wildcards only 
			hiddensystem = 1; 
			if (argv[start][2] == '+') // set hidden,system attrib after copy
				set_hiddensystem = 1; 
			break;

		case 'I': // Input pacing or id changes only
			if (towupper(argv[start][2])==L'D') {
				// Note changes, but do not copy
				id = 1;
				break;
			}

			/* Input Pacing in bytes[K]/seconds */
			/* Force input to arrive no faster than bytes/seconds */
			/* Read block of bytes specified, sleep until seconds */
			
			wcscpy_s(temp,_MAX_PATH,argv[start]+2);
			slash = wcschr(temp,'/');
			if (slash == NULL) {
				input_pacing = 0;
				if (!quiet)
					fprintf(stderr,"Input pacing interval not specified.  Input pacing disabled.\n");
				if (logfi)
					fprintf(logfi,"Input pacing interval not specified.  Input pacing disabled.\n");					
			}
			else {
				input_pacing_interval = _wtol(slash+1) * 1000;
				if (input_pacing_interval <= 0) {
					input_pacing = 0;
					if (!quiet)
						fprintf(stderr,"Input pacing interval <=0.  Input pacing disabled.\n");
					if (logfi)
						fprintf(logfi,"Input pacing interval <=0.  Input pacing disabled.\n");
				}
				*slash = 0;
				if (towupper(*(slash-1)) == 'K') {
					*(slash - 1) = 0;
					mpy = 1024;
				}
				input_pacing = 1;
				input_pacing_size = _wtol(temp);
				if (input_pacing_size <= 0) {
					input_pacing = 0;
					if (!quiet)
						fprintf(stderr,"Input pacing size <=0.  Input pacing disabled.\n");
					if (logfi)
						fprintf(logfi,"Input pacing size <=0.  Input pacing disabled.\n");
				}
				else 
					input_pacing_size *= mpy;

				if (output_pacing) {
					input_pacing = 0;
					if (!quiet)
						fprintf(stderr,"Output pacing previously specified.  Input pacing disabled.\n");
					if (logfi)
						fprintf(logfi,"Output pacing previously specified.  Input pacing disabled.\n");
				}
				else {
					if (!quiet)
						fprintf(stderr,"Input pacing set o %ld bytes / %ld milliseconds.\n",
						input_pacing_size, input_pacing_interval);
					if (logfi)
						fprintf(logfi,"Input Pacing set to %ld bytes / %ld milliseconds.\n",
						input_pacing_size, input_pacing_interval);
				}
			}
			break;
		
		case 'K': // Set blocksize for copy
			blocksize = _wtoi(argv[start]+2);
			if (blocksize > 0 && blocksize < 64)
				blocksi = (unsigned) (blocksize) * 1024;
			else if (blocksize > 0)
				blocksi = (unsigned) (blocksize);

			if (vfile == NULL) 
				;
			else {
				blocksi = (blocksi/vblksi)*vblksi;
				if (blocksi == 0)
					blocksi = vblksi;				
			}
			break;

		case 'L':  /* Log to a File */
			if (argv[start][2] == '-') {
				logall = 0;
				break;
			}
			// Logfile specified
			o=2;
			if (argv[start][o] == '=' || argv[start][o] == ' ')
				++o;
			
			wcscpy_s(temp,_MAX_PATH,argv[start]+o);
			if (_wfopen_s(&logfi,argv[start]+o,L"a")) {
				fprintf(stderr,"Unable to Open %ls\n",argv[start]+o);
				fprintf(stderr,"Logging will be disabled.  Quiet will be disabled.\n");
				quiet = 0;
			}  
			else {
				char ctimebuf[_MAX_PATH];
				time(&logtime);
				ctime_s(ctimebuf,_MAX_PATH,&logtime);
				fprintf(logfi,"%s",ctimebuf);
			}

			if (argv[start][1] == 'L') {
				/* Open a file to contain the list of copied files */
				wcscat_s(temp,_MAX_PATH,L".fil");
				if (_wfopen_s(&cpyfi,temp,L"w")) {
					if (!quiet) {
						fprintf(stderr,"Unable to Open %ls\n",temp);
						fprintf(stderr,"Logging of copied files will be disabled.\n");
					}
					if (logfi) 
						fprintf(logfi,"Logging of copied files will be disabled.\n");
				}
				else
					if (logfi)
						fprintf(logfi,"Copied files will be logged to %s\n",temp);
			}

			break;

		case 'M':	// Move
			move = 1;
			break;

		case 'N':  // Copy newer only or newer existing files only
			fnew = 1;
			if (towupper(argv[start][2]) == 'R')
				repl = 1;
			else 
				if (_wtoi(argv[start]+2) > 0)
					timespan = _wtoi(argv[start]+2);
			break;

		case 'O': // Either output pacing or Safe overwrite
			if (argv[start][2] == 0) {
				// Override specified.  If string doesn't end assume bytes / sec
				overwrite_read_only = 1;
				break;
			}
			if (towupper(argv[start][2]) == L'S') {
				// safeoverwrite chosen
				safeoverwrite = 1;
				break;
			}
			/* Output Pacing in bytes[K]/seconds */
			/* Force output to be sent no faster than bytes/seconds */
			/* Write block of bytes specified, sleep until seconds */
			wcscpy_s(temp,_MAX_PATH,argv[start]+2);
			slash = wcschr(temp,'/');
			if (slash == NULL) {
				output_pacing = 0;
				if (!quiet)
					fprintf(stderr,"Output pacing not specified.  Output pacing disabled.\n");
				if (logfi)
					fprintf(logfi,"Output pacing not specified.  Output pacing disabled.\n");
			}
			else {
				output_pacing_interval = _wtol(slash+1) * 1000;
				if (output_pacing_interval <= 0) {
					output_pacing = 0;
					if (!quiet)
						fprintf(stderr,"Output pacing interval <= 0.  Output pacing disabled.\n");
					if (logfi)
						fprintf(logfi,"Output pacing interval <= 0.  Output pacing disabled.\n");
				}
				*slash = 0;
				if (towupper(*(slash-1)) == 'K') {
					*(slash - 1) = 0;
					mpy = 1024;
				}
				output_pacing_size = _wtol(temp);
				output_pacing = 1;
				if (output_pacing_size <= 0) {
					output_pacing = 0;
					if (!quiet)
						fprintf(stderr,"Output pacing size <= 0.  Output pacing disabled.\n");
					if (logfi)
						fprintf(logfi,"Output pacing size <= 0.  Output pacing disabled.\n");
				}
				else
					output_pacing_size *= mpy;
				if (input_pacing) {
					output_pacing = 0;
					if (!quiet)
						fprintf(stderr,"Input pacing previously specified.  Output pacing disabled.\n");
					if (logfi)
						fprintf(logfi,"Input pacing previously specified.  Output pacing disabled.\n");
				}
				else {
					if (!quiet)
						fprintf(stderr,"Pace output to %ld bytes / %ld milliseconds.\n",
						output_pacing_size, output_pacing_interval);
					if (logfi)
                        fprintf(logfi,"Output pacing set to %ld bytes / %ld milliseconds.\n",
						output_pacing_size, output_pacing_interval);
				}
			}
			break;

		case 'P':	//checkpoints
			checkPoint = 1;
			if (towupper(argv[start][2]) == L'R')
				restart = 1;
			break;
		case 'Q':	//quiet mode, no copyright message
			quiet = 1;
			break;
		case 'R':	//replace existing files only
			repl = 1;
			if (towupper(argv[start][2]) == 'C')
				changed = 1;
			if (towupper(argv[start][2]) == 'N')
				fnew = 1;
			break;
		case 'S': // Copy all directories and subdirectories Recurse through subdirectories
			subdirectories = 1; 
			if (towupper(argv[start][2]) == 'V')
				subverbose = 1;
			break;

		case 'T':
			timeit = 1; // Time the copy operation
			break;
#ifdef VERIFYCRC
		case 'V': // Use the verify option, probably no longer necessary
			wcscpy(verify_name,argv[start]+2);
			vfile = _wfopen(verify_name,L"r");
			if (vfile == NULL) {
				if (!quiet) {
					fprintf(stderr,"Unable to open verification file: %ls\n",vfile);
					perror("");
				}
				if (logfi)
					fprintf(logfi,"Unable to open verification file: %ls\n",vfile);
				close_log_files();
				exit(15);
			}
			fgetws(vname,_MAX_PATH,vfile); /* get name of file being verified */
			fgetws(vsize,15,vfile);    /* get size of file being verified */
			fgetws(vctime,32,vfile);	  /* get file date, time stamp */
			fgetws(vtime,15,vfile);    /* get date-time as time_t */
			fgetws(vblock,15,vfile);   /* get blocksize */
			checkPoint = 1;
			vblksi = _wtoi(vblock);
			blocksi = (blocksi/vblksi)*vblksi;
			if (blocksi == 0)
				blocksi = vblksi;				
/*			printf("Using verification file: %s\n",verify_name); */
/*			printf("Verifying file %s",vname); */
/*			printf("Size is: %ld bytes\nLast Updated: %s",atol(vsize),vctime); */
/*			printf("BLOCKSIZE set to %d\n",atoi(vblock)); */
			break;
#endif
		case 'W':
			/* When using Windows Version, check version info */
			/* Only check dates if versions match */
			fnew = 1;
			wnew = 1;
			if (towupper(argv[start][2]) == 'R')
				repl = 1;
			else 
				if (_wtoi(argv[start]+2) > 0)
					timespan = _wtoi(argv[start]+2);
			break;
		case 'X': // exclude list;
			if (wcslen(argv[start]) > 2) 
				if (argv[start][2] == '=') {
					// syntax is -x= followed by list of excluded files
					// gather info to right of =
					ln = wcslen(argv[start]) - 3;
					offset = 3;
				}
				else {
					fprintf(stderr, "%ls <=== Invalid.\n", argv[start]);
					exit(8);
				}
			else {
				// Syntax is -x ...  list of files
				// list of files in in next argument
				offset = 0;
				ln = wcslen(argv[++start]);
			}
			exclude_arg = malloc(ln * sizeof(temp[0]) + sizeof(temp[0]));
			exclude_arg_size = ln + 1;
			// remove leading " if present
			if (argv[start][offset] == L'"') {
				++offset;
				--ln;
			}
			// removing trailing " if presetnt
			if (argv[start][offset+ln-1] == L'"')
				--ln;
			// Copy list of files to exclude_arg;
			wcscpy_s(exclude_arg,exclude_arg_size,argv[start]+offset);
			translate(exclude_arg,L"\\",L"/");
			_wcsupr_s(exclude_arg,exclude_arg_size);
			// moved list of files to exclude_arg, now parse looking for ;
			// create first entry pointing to the strings
			// look for semilcolons in the string and if found, add to 
			// linked list.
			exclude_entry = (struct exclude_struct *) malloc(sizeof(exclude_temp));
			first_exclude = exclude_entry;
			val = exclude_arg;
			exclude_entry->next = NULL;
			exclude_entry->value= val;
			while ((val = wcschr(val,L';')) != NULL) {
				// found a ;  set end of previous string, create next entry and point to
				// data following ;
				*val = 0;
				++val;
				current_exclude = exclude_entry;
				exclude_entry = (struct exclude_struct *) malloc(sizeof(exclude_temp));
				current_exclude -> next = exclude_entry;
				exclude_entry -> next = NULL;
				exclude_entry -> value = val;
			}
			current_exclude = NULL;
			exclude_entry = NULL;
			break;

		default:
			if (!quiet)
				fprintf(stderr,"%ls <=== Unknown Flag.\n",argv[start]);
			if (logfi)
				fprintf(logfi,"%ls <=== Unknown Flag.\n",argv[start]);
			rc = 12;
		}
	}

	if (rc > 0) {
		fprintf(stderr,"CP is stopping due to unknown/invalid flags!\n");
		if (logfi)
			fprintf(stderr,"CP is stopping due to unknown/invalid flags!\n");
		close_log_files();
        exit(12);
    }

	if (logfi) {
		for (i=0; i < argc; ++i) 
			fprintf(logfi,"%ls ",argv[i]);
		fprintf(logfi,"\n");
	}
}

void delete_source(wchar_t *from_path)	{
	if (_wunlink(from_path) == 0) {
		if (logfi)
			fprintf(logfi,"%ls deleted.\n",from_path);
	}
	else {
		if (!quiet) {
			fprintf(stderr,"Unable to delete %ls\n",from_path);
			perror("");
		}
		if (logfi)
			fprintf(logfi,"Unable to delete %ls\n",from_path);
	}
}

/* Copy this file if it passes the tests specified in the flags */
/* Make archive if necessary */
int copy_if_selected(wchar_t *tofull,wchar_t *fromfull,int todir,int argc) {
	TCHAR fileversion[16];
	TCHAR oldname[_MAX_PATH], newname[_MAX_PATH];
	TCHAR todrive[_MAX_DRIVE],todirr[_MAX_DIR],tofname[_MAX_FNAME],toext[_MAX_EXT];
	int newtype,rc1,k,rc=0;
	TCHAR temp_path[_MAX_PATH], *s, *colon, temp_path_to[_MAX_PATH];
	_int64 tosize, fromsize;
	FILE *fi;
	int fih, statcode, xxx, yyy;

	wcscpy_s(temp_path,_MAX_PATH,fromfull);
//	if the name specifies a stream, then remove stream info
	s = temp_path;
	if (temp_path[1]==L':')
		s += 2;
	colon = wcschr(s,L':');
	if (colon) // There is another colon in the name.  The name specifies a stream
		*colon = 0;

	tosize = -1;
	fromsize = -1;

	if (colon) {
		// The from file is a stream.  Get its actual size
		// the hard way
		if (_wfopen_s(&fi,fromfull,L"r") || fi==NULL)
			return 1;
		fih = _fileno(fi);
		fromsize = _filelengthi64(fih);
		fclose(fi);
	}

//	fi = _wfopen(temp_path,"rb");
	xxx = S_IFREG;
	yyy = S_IFDIR;

	statcode=_wstati64(temp_path,&dta);
	if (statcode == 0  && (dta.st_mode & S_IFREG) == S_IFREG ) { 
		winFileVersion(temp_path,from_version);
		if (colon) 
			dta.st_size = fromsize;
		wcscpy_s(temp_path_to,_MAX_PATH,tofull);
	//	if the name specifies a stream, then remove stream info
		s = temp_path;
		if (temp_path[1]==L':')
			s += 2;
		colon = wcschr(s,L':');
		if (colon) // There is another colon in the name.  The name specifies a stream
			*colon = 0;
		
		if (colon) {
		// The to file is a stream.  Get its actual size the hard way
			if (_wfopen_s(&fi,tofull,L"r") || fi == NULL)
				;
			else {
				fih = _fileno(fi);
				tosize = _filelengthi64(fih);
				fclose(fi);
			}
		}

		rc = _wstat64(temp_path_to,&dta1); /* get destination info */		

		if (colon)
			dta1.st_size = tosize;

		if (repl) {
			// replacing, now must check if dealing with streams
			if (colon) {
				// tofile specifies a stream.  Let's see if it exists
				// open using fopen.  If ok, then the file exists
				if (tosize == -1)
					rc = 1;  // set rc to indicate that dest doesn't exist
			}
		}

		if (todir && rc && repl) {
			// if no destintion file and -r specified, done
			if (logfi && logall) {
				fprintf(logfi,"%ls ===> %ls",fromfull,tofull);
				fprintf(logfi," : Destination file does not exist.\n");
			}
			return 0;		/* skip file, doesn't exist in receiving direcory */
		}

		if (file_excluded(fromfull))
			return 0;	// Skip this file because it matches a pattern in the exclude list

		if (fnew && rc == 0) {
			/* if the file exists, get its windows version info */
			/* this will be set to 0,0 if no version info is present */
			winFileVersion(temp_path_to,to_version);
			if (DestIsNewer(fromfull,tofull))
				return 0;
		} /* skip file, isn't newer than receiving file */

		if (changed && rc == 0) {
			winFileVersion(temp_path_to, to_version);
			if ((abs(dta.st_mtime == dta1.st_mtime) <= 2) &&
				to_version[0] == from_version[0] &&
				to_version[1] == from_version[1] &&
			    (dta.st_size  == dta1.st_size))
			{
				if (logfi && logall)
					fprintf(logfi,"%ls ===> %ls : Files are the same.\n",fromfull,tofull);
				return 0; /* skip file, isn't different than receiving file */
			}
		}
		
		if (badVerificationFile(vfile,_wctime(&dta.st_mtime),vctime,dta.st_size,_wtol(vsize)))
			return 1;	

		if (rc == 0 && archive) { /* Receiving File Exists */
			if (colon) {
				// output is a stream.  -a, -g are meaningless.  Do not copy.
				p_error(7,fromfull,tofull);
				return 1;
			}
			_wsplitpath_s(tofull,todrive,_MAX_DRIVE,todirr,_MAX_DIR,tofname,_MAX_FNAME,toext,_MAX_EXT); 
		    /* need to rename existing files */
			swprintf_s(fileversion,8,L".(%3d)",versions+99);
			fileversion[2]=L'-';
			wcscpy_s(newname,_MAX_PATH,todrive);
			wcscat_s(newname,_MAX_PATH,todirr);
			wcscat_s(newname,_MAX_PATH,tofname);
			wcscat_s(newname,_MAX_PATH,fileversion);
			wcscat_s(newname,_MAX_PATH,toext);
			/* _makepath(newname,todrive,todirr,tofname,toext); */
			if (id) {
				// make no changes
			}
			else {
				rc1 = _wunlink(newname);	
				if (rc1 == 0 && logfi)
					fprintf(logfi,"%ls has been deleted.\n",newname);
//				else 
//					_wperror(newname);
				/* printf("UNLINK %s : %d\n",newname,rc1); */
				for (newtype=versions-1;newtype > 1;--newtype) {
					wsprintf(fileversion,L".(%3d)",newtype+100);
					fileversion[2] = '-';
					/* _makepath(newname,todrive,todirr,tofname,toext); */
					wcscpy_s(newname,_MAX_PATH,todrive);
					wcscat_s(newname,_MAX_PATH,todirr);
					wcscat_s(newname,_MAX_PATH,tofname);
					wcscat_s(newname,_MAX_PATH,fileversion);
					wcscat_s(newname,_MAX_PATH,toext);
					wsprintf(fileversion,L".(%3d)",newtype+99);
					fileversion[2] = '-';
					wcscpy_s(oldname,_MAX_PATH,todrive);
					wcscat_s(oldname,_MAX_PATH,todirr);
					wcscat_s(oldname,_MAX_PATH,tofname);
					wcscat_s(oldname,_MAX_PATH,fileversion);
					wcscat_s(oldname,_MAX_PATH,toext);					
					/* _makepath(oldname,todrive,todirr,tofname,toext); */
					rc1 = _wrename(oldname,newname);
					if (rc1 == 0 && logfi)
						fprintf(logfi,"%ls renamed to %ls\n",oldname,newname);
					/* printf("%s ===> %s : %d\n",oldname, newname, rc1); */
					wcscpy_s(newname,_MAX_PATH,oldname);
				}
			
				// If the filenames are the same and archvie is set, do not rename
				// file to filename.(-01), so copy to file filename.(-01) instead
				if (wcscmp(fileversion,L".(-01)") == 0 && _wcsicmp(tofull,fromfull) == 0) {
					rc1 = -1;
					wcscat_s(tofull,_MAX_PATH,L".(-01)");
				}
				else
					rc1 = _wrename(tofull,newname);
				if (rc1 == 0 && logfi)
					fprintf(logfi,"%ls renamed to %ls\n",tofull,newname);
				/* printf("%s ===> %s : %d\n",tofull,oldname,rc1); */
			}
		}

		/* Copy the File */
		if (logfi)
			fprintf(logfi,"%ls ===> %ls",fromfull,tofull);
		if (!quiet){
			if (id) {
				printf("%12I64d\t%ls\n",dta.st_size,fromfull);
				filekt++;
				totalSize+=dta.st_size;
				errkt = 0;
			}
			else 
				printf("%ls ===> %ls",fromfull,tofull);
		}
		rc = 0;
		if (id) {
		}

		else if ((k = copyfile(fromfull,tofull,dta.st_atime,dta.st_mtime,checkPoint,restart,useCopyFile)) == 0) {
			if (!quiet)
				printf(" : Ok\n");
			if (logfi)
				fprintf(logfi," : Ok\n");
			if (cpyfi)
				fprintf(cpyfi,"%s\n",fromfull);
			if (move && nextto == argc) 
				delete_source(fromfull);
		}
		else {
			p_error(k,fromfull,tofull);
			rc = 1;
		}

		if (errkt) {
			if (!quiet)
				printf("\t%d CRC failures occurred during the copy.\n",errkt);
			if (logfi)
				fprintf(logfi,"\t%d CRC failures occurred during the copy.\n",errkt);
		}
	
	}
	else if ((dta.st_mode & S_IFDIR) == 0) {
		p_error(1,fromfull,tofull);
		rc = 1;
	}
	return rc;
}

int copy_dir(wchar_t *frompath,wchar_t *topath,int argc) {
	// This routine copies an entire directory from the
	// frompath to the topath.  Each file to be copied
	// is tested against the flags before being copied
	// so that newer, replacement, change and windows
	// versioning still applies. 
	// If the subdirectories flag is set, then all sub-
	// directories are copied as well.
int rc, return_code = 0, return_code_max = 0;
wchar_t c,pathdir[_MAX_PATH], newfrom[_MAX_PATH], newto[_MAX_PATH];
char todir = 0, destination_error = 0;
long path_handle;
char blanks[] = "                                                                               ";

    if (subverbose)
       if (!quiet)
          printf("\r%s\r%ls\r",blanks,frompath);

	wcscpy_s(pathdir, _MAX_PATH,frompath);
	c = pathdir[wcslen(pathdir) -1]; // set c to last char
	if (c == '/' || c == '\\')
		;
	else
		wcscat_s(pathdir,_MAX_PATH,L"/");  // make sure path ends in slash
	wcscat_s(pathdir,_MAX_PATH,L"*.*");	  // followed by *.*

/* look for all files, including hidden and system */
/* return name of first file found that is not a sub-directory */
/* return name of a hidden-system file only if hiddensystem == 1 */
	for (rc=0,path_handle=_wfindfirst(pathdir,&finddata);
		path_handle != -1L && rc == 0;
	    rc=_wfindnext(path_handle,&finddata)) {
		
		// found an entry, create new destination name
		// this is either a file or directory
		wcscpy_s(newto,_MAX_PATH,topath);
		c = newto[wcslen(newto) -1];
		if (c == L'/' || c == L'\\')
			;
		else
			wcscat_s(newto,_MAX_PATH,L"/");
		wcscat_s(newto,_MAX_PATH,finddata.name);

		// Create new source address
		// may point to a file or be a directroy
		wcscpy_s(newfrom,_MAX_PATH,frompath);
		c = newfrom[wcslen(newfrom) - 1];
		if (c == '/' || c == '\\')
			;
		else
			wcscat_s(newfrom,_MAX_PATH,L"/");
		wcscat_s(newfrom,_MAX_PATH,finddata.name);	
			
		if (finddata.attrib & _A_SUBDIR) {
			if (wcscmp(finddata.name,L".") == 0 || 
				wcscmp(finddata.name,L"..") == 0)
				continue;

			if (subdirectories) {
				// Copying files from new directory just found
			    // to equivalent directory structure in from
				// path.
				// Now copy new directories
				if ((rc = is_dir(newto)) == 1) {
				/* path is a directory; set flags and continue */
					todir = 1;
					destination_error = 0;
				}
				else {
				/* path either does not exist or is a file */
				/* Assume it does not exist and create directory struc */
					if (id) {
						// Don't make any changes
						todir = 1;
					}
					else {
						todir = 0;
						if (mk_all_dir(newto) == 0) {
							destination_error = 0;
							todir = 1;
							if (!quiet)
								printf("Directory: %ls has been created.\n", newto);
							if (logfi)
								fprintf(logfi,"Directory: %ls has been created.\n", newto);
						}
						else { /* if we can't make the directory, have an error */
							destination_error = 1;
							if (!quiet) {
								printf("%ls: Unable to create destination directory.\n",newto);
								perror("");
							}
							if (logfi)
								fprintf(logfi,"%ls: Unable to create destination directory.\n",newto);
							return_code = 8;
							if (return_code > return_code_max)
								return_code_max = return_code;
							continue;
						}
					}
				}
				return_code = copy_dir(newfrom,newto,argc);
				if (return_code > return_code_max)
					return_code_max = return_code;
				continue; // Look at new file in directory
			}
		}
		// have an actual file to copy, check hiddensystem
		if (!hiddensystem && (finddata.attrib & 
		    (_A_HIDDEN | _A_SYSTEM)))
			continue;
	
		// Now copy the file
		todir = 1; // force todir, always go to a dir here
		return_code = copy_if_selected(newto,newfrom,todir,argc);
		if (return_code > return_code_max)
			return_code_max = return_code;
	}

	/* Reached end of list */
	if (rc == 0) // did not find even one candidate
		;
	else
		_findclose(path_handle);  // Shut down find

	return return_code_max;  // Done
}

void wmain(int argc,wchar_t *argv[]) {
	int nextarg, wildcard=0;
	FILE *fromfi;
	int todir,k,return_code = 0;
	int rc=0,toflag,toidx,outidx;
	char destination_error=0;
	wchar_t from_path[_MAX_PATH],to_path[_MAX_PATH];

	tofi = NULL;
	fromfi = NULL;
	/* scan for flag values in argv and set processing indicators */
	set_flags(argc,argv);

	if (input_pacing || output_pacing)
		timeBeginPeriod(1);

	/* look for -TO in arguments */
	for (toflag=0,toidx=start+1;toidx<argc-1 && toflag==0; toidx++)
		if (_wcsicmp(argv[toidx],L"-TO") == 0)
			toflag = 1;

		//SendMessage(hwndPB, PBM_SETPOS, (WPARAM) 0, 0);
	/* If not at least a from and to file, display help */
	if (argc+start-1 < 3) 
		Usage();

	if (toflag) {
		outidx = toidx; /* set to 1st output file */
		--toidx;        /* set to last input file+1 */
	}
	else {
		toidx = argc - 1;
		outidx = toidx;
	}

	/* look for an destination; when you find one copy all source */
	nextto = outidx;
	while (next_output(to_path,argc,argv)) {
		if (_wfullpath(topath,to_path,_MAX_PATH) == NULL) {
			if (!quiet)
				printf("%s: Invalid destination.\n",to_path);
			if (logfi)
				fprintf(logfi,"%s: Invalid destination.\n",to_path);
			destination_error = 1;
			return_code = 8;
			continue;
		}
			
		if (topath[1]==':' && (topath[2]==0 || (topath[2]=='.' && topath[3]==0)))
			_wgetdcwd(towupper(topath[0])-L'@',topath,sizeof(topath));
		else if (topath[0]=='.' && topath[1]==0)
			_wgetcwd(topath,sizeof(topath));

		if ((rc = is_dir(topath)) == 1) {
			/* path is a directory; set flags and continue */
			todir = 1;
			destination_error = 0;
			k = wcslen(topath) - 1;
			if (topath[k] == '/' || topath[k] == '\\')
				topath[k] = 0; /* path shouldn't end with a / */
		}
		else {
			/* path either does not exist or is a file */
			todir = 0;
			k = wcslen(to_path) - 1;
			/* If the path name ends in a / or \; then create a directroy
			with this path name and consider path to be a directory */
			if ((to_path[k] == '/' || to_path[k] == '\\')) {
				if (id==1) {
					// make no changes
				}
				else {
					if (mk_all_dir(topath) == 0) {
						destination_error = 0;
						todir = 1;
						if (!quiet)
							printf("Directory: %lls has been created.\n", topath);
						if (logfi)
							fprintf(logfi,"Directory: %ls has been created.\n", topath);
					}
					else { /* if we can't make the directory, have an error */
						destination_error = 1;
						if (!quiet) {
							printf("%ls: Unable to create destination directory.\n",topath);
							perror("");
						}
						if (logfi)
							fprintf(logfi,"%ls: Unable to create destination directory.\n",topath);
						return_code = 8;
						continue;
					}
				}
			}
		}

		
		if (((toidx - start) > 1 || 
			(argv[start][0] == '@' && is_dir(argv[start]) == 0)) && !todir) {
			/* If there is more than one file in the from list then the
			destination must be one or more directories.
			If toidx - start > 1 then there is more than one entry in the list
			If there is only one entry and it starts with @ and it is not
				a file that begins with the @ character, then there is more
				than one entry in the list
			If the destination does not exist; create a directory */
			if (rc != 0) {
				if (id == 0) {			
					/* Create new directory for destination */
					if (mk_all_dir(topath) == 0) {
						destination_error = 0;
						todir = 1;
						if (!quiet)
							printf("Directory: %s has been created.\n", topath);
						if (logfi)
							fprintf(logfi,"Directory: %s has been created.\n", topath);
					}
					else {
						destination_error = 1;
						if (!quiet)
							printf("%s: Unable to create destination directory.\n",topath);
						if (logfi)
							fprintf(logfi,"%s: Unable to create destination directory.\n",topath);
						perror("");
					}
				}
			}
			else
				destination_error = 1;

			if (destination_error) {
				if (!quiet) {
					if (batch)
						printf("%ls <=== target not a directory.\n",topath);
					else
						fprintf(stderr,"%ls <=== target not a directory.\n",topath);
				}
				if (logfi)
					fprintf(logfi,"%s <=== target not a directory.\n",topath);
				return_code = 9;
				continue;
			}
		}

		/* allocate buffers until no more room */
		if (firsttime==0) {
			buflen = allocate_buffers(checkPoint);
			if (blocksi < buflen)
				buflen = blocksi;
			
			if (blocksize > 0) {
				if (!batch && !quiet)
					printf("BLOCKSIZE = %u\n",buflen);
				if (logfi)
					fprintf(stderr,"BLOCKSIZE = %u\n",buflen);
			}
			firsttime=1;
		}

		/* Copy each input file to output */
		nextarg = start;
		while (next_input(from_path,toidx,argv,&wildcard,&nextarg,fromfi)) {

			if (is_dir(from_path) == 1) {
				/* Copy Entire Directory to topath */
				rc = copy_dir(from_path,topath,argc);
				continue;
			}

			if (todir) {
				/* Build output file name from path name, input name */
				for (k=wcslen(from_path)-1;k>=0 && from_path[k] != '\\' &&
                        from_path[k] != '/' && from_path[k] != ':'; --k) ;
				    ++k; /* point to start of file name */
				wcscpy_s(toname,_MAX_PATH,topath);
				wcscat_s(toname,_MAX_PATH,DELIM);
				wcscat_s(toname,_MAX_PATH,from_path+k);
			}
			else
				wcscpy_s(toname,_MAX_PATH,topath);

			_wfullpath(tofull,toname,_MAX_PATH);
			_wfullpath(fromfull,from_path,_MAX_PATH);

			/* look for source file, if found check destination file */
			rc = copy_if_selected(tofull,fromfull,todir,argc);
		}
	}

    if (vfile != NULL)
        fclose(vfile);

	free_all_buffs(); /* Free allocated buffers */
	timeEndPeriod(1);
	if (logfi != NULL)
		fprintf(logfi,"Error Level %d\n",return_code == 0 ? rc : (rc == 0 ? return_code : rc));
	close_log_files();
	if (ProgressBar) {
		KillProgressBar();
	}

	if (id) {
		printf("%d files, %I64d Bytes\n",filekt,totalSize);
	}
	exit(return_code == 0 ? rc : (rc == 0 ? return_code : rc));
}


#ifdef MAKETAB
main()
{
	initcrctab();
}

initcrctab()
{
	register  b, v, i;


	for ( b = 0; b <= (1<<B)-1; ++b ) {
		for ( v = b<<(W-B), i = B; --i >= 0; )
			v = v&0x8000 ? (v<<1) ^P : v<<1;
		crctab[b] = v;

		printf( "0x%04x,", v & 0xFFFF );
		if ( (b&7) == 7 )
			printf("\n" );
		else
			printf("  ");
	}
}
#endif

#ifdef TEST

#include <stdio.h>
#include <fcntl.h>

#define MAXBUF  32000

main( ac, av )
int ac; 
wchar_t **av;
{
	int fd = 0;
	int nr;
	wchar_t buf[MAXBUF];
	unsigned short crc;

	if ( ac > 1 )
		if ( (fd = open( av[1], O_RDONLY )) < 0 ) {
			perror( av[1] );
			exit( -1 );
		}
	crc = 0;
	while ( (nr = read( fd, buf, MAXBUF )) > 0 )
		crc = updcrc( crc, buf, nr );
	printf( "%04x\n", crc );
	if ( nr != 0 )
		perror( "reading" );
}

#endif
